package com.cmmap.api.maps.model;


/**
 * 交通路况拥堵对应的颜色属性
 */
public class MyTrafficStyle {
	/**
	 * 返回行驶拥堵路段的标记颜色
	 */
	private int CongestedColor;
	
	/**
	 * 严重拥堵颜色
	 */
	private int SeriousCongestedColor;
	
	/**
	 * 行驶缓慢路段的标记颜色
	 */
	private int SlowColor;
	
	
	/**
	 * 行驶畅通路段的标记颜色
	 */
	private int SmoothColor;
	
	/**
	 * 返回交通路况畅通颜色值。
	 * @return 交通路况畅通颜色值，ARGB值，参见{@link android.graphics.Color}，默认：0xff00a209
	 */
	public int getSmoothColor() {
		return SmoothColor;
	}

	/**
	 * 设置交通路况畅通颜色值。
	 * @param color 颜色值
	 */
	public void setSmoothColor(int color) {
		SmoothColor = color;
	}

	/**
	 * 返回交通路况缓行颜色值。
	 * @return 交通路况缓行颜色值，ARGB值，参见{@link android.graphics.Color}，默认：0xffff7508
	 */
	public int getSlowColor() {
		return SlowColor;
	}

	/**
	 * 设置交通路况缓行颜色值。
	 * @param color 颜色值
	 */
	public void setSlowColor(int color) {
		SlowColor = color;
	}

	/**
	 * 返回交通路况拥堵颜色值。
	 * @return 交通路况拥堵颜色值，ARGB值，参见{@link android.graphics.Color}，默认：0xffea0312
	 */
	public int getCongestedColor() {
		return CongestedColor;
	}

	/**
	 * 设置交通路况拥堵颜色值。
	 * @param color 颜色值
	 */
	public void setCongestedColor(int color) {
		CongestedColor = color;
	}

	/**
	 * 返回交通路况严重拥堵颜色值。
	 * @return 交通路况拥堵颜色值，ARGB值，参见{@link android.graphics.Color}，默认：0xff92000
	 */
	public int getSeriousCongestedColor() {
		return SeriousCongestedColor;
	}

	/**
	 * 设置交通路况严重拥堵颜色值。
	 * @param color 颜色值
	 */
	public void setSeriousCongestedColor(int color) {
		SeriousCongestedColor = color;
	}
}
