package com.cmmap.api.maps.model;


/**
 * 栅格瓦片信息类。
 * <p>通过调用{@link TileProvider}方法，可以生成栅格瓦片信息对象。</p>
 */
public final class Tile {
	/** 栅格瓦片的像素宽度 */
	public final int width;
	/** 栅格瓦片的像素高度 */
	public final int height;
	/** 栅格瓦片的内容字节数组 */
	public final byte[] data;

	/**
	 * 构造函数。
	 * @param width 栅格瓦片的像素宽度
	 * @param height 栅格瓦片的像素高度
	 * @param data 栅格瓦片的内容字节数组
	 */
	public Tile(int width, int height, byte[] data) {
		this.height = height;
		this.width = width;
		this.data = data;
	}
}
