package com.cmmap.api.maps.offlinemap;

/**
 * 地图下载状态码。 
 * <p>如果状态码小于0，即需要重新下载进行处理，再次开始下载就会自动删除并下载。</p>
 */
public class OfflineMapStatus {
	/** 默认状态 */
	public static final int NONE = 0;
	/** 正在下载 */
	public static final int DOWNLOADING = 1;
	/** 暂停下载 */
	public static final int PAUSE = 2;
	/** 等待下载 */
	public static final int WAITING = 3;
	/** 下载成功 */
	public static final int DOWNLOADED = 4;
	/** 正在解压 */
	public static final int UNZIPING = 5;
	/** 下载完成 */
	public static final int FINISHED = 6;
	/** 有更新 */
	public static final int NEW_VERSION = 7;
	/** 鉴权失败 */
	public static final int EXCEPTION_AUTH = 8;
	/** 网络错误 */
	public static final int EXCEPTION_NETWORK = 9;
	/** 数据验证失败 */
	public static final int EXCEPTION_DATA = 10;
	/** SD卡读写异常 */
	public static final int EXCEPTION_SDCARD = 11;
}
