package com.cmmap.internal.driver.base;

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.provider.Settings;
import android.telephony.TelephonyManager;
import android.util.Log;

public class DeviceTool {
	public static String getIMEI() {
		String strIMEI = "";
		try {
			Context context = GlobalSettings.getInstance().getContext();
			TelephonyManager telephonyManager = (TelephonyManager) context.getSystemService(Context.TELEPHONY_SERVICE);
			strIMEI = telephonyManager.getDeviceId();
		}
		catch (Exception e){
			e.printStackTrace();
		}
		return strIMEI;
	}
	
	public static String getIMSI() {
		String strIMSI = "";
		try {
			Context context = GlobalSettings.getInstance().getContext();
			TelephonyManager mTelephonyMgr = (TelephonyManager) context.getSystemService(Context.TELEPHONY_SERVICE);
			strIMSI = mTelephonyMgr.getSubscriberId();	
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return strIMSI;
	}	
	
	public static String getAndroidId() {
		String strAndroidId = "";
		try {
			Context context = GlobalSettings.getInstance().getContext();
			strAndroidId = Settings.System.getString(context.getContentResolver(), Settings.System.ANDROID_ID);			
		}
		catch (Exception e){
			e.printStackTrace();
		}
		if(strAndroidId == null || strAndroidId.isEmpty()) {
			try {
				Context context = GlobalSettings.getInstance().getContext();
				TelephonyManager mTelephonyMgr = (TelephonyManager) context.getSystemService(Context.TELEPHONY_SERVICE);
				strAndroidId = mTelephonyMgr.getSimSerialNumber();	
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		return strAndroidId;
	}

	public static String GetNetworkType()
	{
	    String strNetworkType = "";
	    try {
		    Context context = GlobalSettings.getInstance().getContext();
		    ConnectivityManager conManager = (ConnectivityManager)context.getSystemService(Context.CONNECTIVITY_SERVICE);
		    NetworkInfo networkInfo = conManager.getActiveNetworkInfo();
		    if (networkInfo != null && networkInfo.isConnected())
		    {
		        if (networkInfo.getType() == ConnectivityManager.TYPE_WIFI)
		        {
		            strNetworkType = "WIFI";
		        }
		        else if (networkInfo.getType() == ConnectivityManager.TYPE_MOBILE)
		        {
		            String _strSubTypeName = networkInfo.getSubtypeName();            
		            // TD-SCDMA   networkType is 17
		            int networkType = networkInfo.getSubtype();
		            switch (networkType) {
		                case TelephonyManager.NETWORK_TYPE_GPRS:
		                case TelephonyManager.NETWORK_TYPE_EDGE:
		                case TelephonyManager.NETWORK_TYPE_CDMA:
		                case TelephonyManager.NETWORK_TYPE_1xRTT:
		                case TelephonyManager.NETWORK_TYPE_IDEN: //api<8 : replace by 11
		                    strNetworkType = "2G";
		                    break;
		                case TelephonyManager.NETWORK_TYPE_UMTS:
		                case TelephonyManager.NETWORK_TYPE_EVDO_0:
		                case TelephonyManager.NETWORK_TYPE_EVDO_A:
		                case TelephonyManager.NETWORK_TYPE_HSDPA:
		                case TelephonyManager.NETWORK_TYPE_HSUPA:
		                case TelephonyManager.NETWORK_TYPE_HSPA:
		                case TelephonyManager.NETWORK_TYPE_EVDO_B: //api<9 : replace by 14
		                case TelephonyManager.NETWORK_TYPE_EHRPD:  //api<11 : replace by 12
		                case TelephonyManager.NETWORK_TYPE_HSPAP:  //api<13 : replace by 15
		                    strNetworkType = "3G";
		                    break;
		                case TelephonyManager.NETWORK_TYPE_LTE:    //api<11 : replace by 13
		                    strNetworkType = "4G";
		                    break;
		                default:
		                    // http://baike.baidu.com/item/TD-SCDMA 中国移动 联通 电信 三种3G制式
		                    if (_strSubTypeName.equalsIgnoreCase("TD-SCDMA") || _strSubTypeName.equalsIgnoreCase("WCDMA") || _strSubTypeName.equalsIgnoreCase("CDMA2000")) 
		                    {
		                        strNetworkType = "3G";
		                    }
		                    else
		                    {
		                        strNetworkType = _strSubTypeName;
		                    }                    
		                    break;
		            }
		        }
		    }
	    }
	    catch (Exception e) {
	    	e.printStackTrace();
	    }
	    Log.i("DeviceTool", "NetworkType="+strNetworkType);
	    return strNetworkType;
	}
}
