package com.cmmap.internal.driver.broadcastReceiver;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Handler;
import android.util.Log;
import android.widget.Toast;

import com.cmmap.internal.mapcore.MapCore;
import com.cmmap.internal.mapcore.offlinemap.UpdateThread;
import com.cmmap.internal.maps.KMapInitializer;

public class NetWorkMonitorReceiver extends BroadcastReceiver {
	public static String TAG = NetWorkMonitorReceiver.class.getName();
	public static NET_TYPE NetType = NET_TYPE.no_net;
	UpdateThread mUpdateThread = null;

	private Handler m_handler;
	public enum NET_TYPE {
		no_net,wifi,mobile
	}

	public Handler getM_handler() {
		return m_handler;
	}
	
	public void setM_handler(Handler m_handler) {
		this.m_handler = m_handler;
	}
	
	public void Release() {
		if (mUpdateThread != null) {
			mUpdateThread.Release();
			mUpdateThread = null;
		}
	}
	
	@Override
	public void onReceive(Context context, Intent intent) {
		Log.i(TAG, "KMapView registerReceiver onReceive " +intent.getAction());
		ConnectivityManager connManager=(ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo mobNetInfo = connManager.getNetworkInfo(ConnectivityManager.TYPE_MOBILE);
		NetworkInfo wifiNetInfo = connManager.getNetworkInfo(ConnectivityManager.TYPE_WIFI);
		if(KMapInitializer.isIntialized()
				&& mUpdateThread == null){
			mUpdateThread = new UpdateThread(m_handler, null);
			mUpdateThread.start();
		}
		
		if(mobNetInfo!=null && wifiNetInfo!=null) {
			//网络不可用  没有WiFi 也没有移动数据
			if (!mobNetInfo.isConnected() && !wifiNetInfo.isConnected()) {
				NetWorkMonitorReceiver.NetType = NET_TYPE.no_net;
				if(KMapInitializer.isIntialized()){
					MapCore.setNetworkStatus(0);
				}
			}
			//网络可用 
			else {
				// wifi连接
				if (wifiNetInfo.isConnected()) {
					NetWorkMonitorReceiver.NetType = NET_TYPE.wifi;
					Log.i(TAG, "wifNetInfo connection!");
					if(KMapInitializer.isIntialized()){
						MapCore.setNetworkStatus(1);
					}
				}
				// 移动网络连接
				else if(mobNetInfo.isConnected()) {
					NetWorkMonitorReceiver.NetType = NET_TYPE.mobile;
					Log.i(TAG, "mobNetInfo connection!");
					if(KMapInitializer.isIntialized()){
						MapCore.setNetworkStatus(2);
					}
				}
			}	
		}else {
			NetWorkMonitorReceiver.NetType = NET_TYPE.no_net;
			if(KMapInitializer.isIntialized()){
				MapCore.setNetworkStatus(0);
			}
		}
		
	}

}
