package com.cmmap.internal.driver.gesture;

import android.graphics.Point;
import android.view.MotionEvent;

import com.cmmap.internal.driver.view.MapParams;
import com.cmmap.internal.maps.model.KLatLng;

/**
 * [internal] 地图手势监听
 * @author liangz
 * 
 */
public interface MapGestureListener {
	//[internal] 手势开始
	void onGestureStart();
	//[internal] 刷新图层  
	void onRefreshInfoLayer();
	//[internal] 手势结束
	void onGestureEnd();
	//[internal] 点击地图
	void onMapClick(Point point);
	//[internal] 长按地图
	void onMapLongClick(KLatLng location);
	//[internal] 操作地图参数变化
	void onMapChanged(MapParams params);
	
	/**
	 * 地图触摸
	 * @param event
	 */
	void onMapTouch(MotionEvent event);
	
}
