package com.cmmap.internal.driver.service;

import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;
import java.util.concurrent.ThreadPoolExecutor;

import android.util.Log;

import com.cmmap.internal.driver.base.GlobalSettings;
import com.cmmap.internal.mapcore.KHttpData;




/**
 * [internal]service做网络处理請求
 * @author liangz
 *
 */
public class DownloadInvoke implements IServiceInvoke{

	private static ConcurrentMap<KHttpData, DownloadTask> taskMap;
	public DownloadInvoke(){
		if(taskMap == null){
			taskMap = new ConcurrentHashMap<KHttpData, DownloadTask>();
		}
	}
	@Override
	public void invoke(KHttpData data) {
		if(data != null){
			if(taskMap != null){
				if(!taskMap.containsKey(data)){
					DownloadTask task = new DownloadTask(data);
					taskMap.put(data, task);
					GlobalSettings.getInstance().getWorkThreadPool().execute(task);				
				}
				else
				{
					Log.e("download", String.format("rct=(%d,%d,%d,%d),url=%s", 
							data.m_Rect.iLeft, data.m_Rect.iBottom, data.m_Rect.iRight, data.m_Rect.iTop, data.m_str_url));
					data.release();
				}
			}
		}
	}

	//[internal]关闭无用httpClient
	public void colseTask(KHttpData data){
		if(taskMap != null){
			if(data != null){
				DownloadTask task = taskMap.remove(data);
				if(task != null){
					task.shutDownClient();
					((ThreadPoolExecutor)GlobalSettings.getInstance().getWorkThreadPool()).remove(task);
				}
			}
//			System.out.println("==============colseTask getActiveCount:"+((ThreadPoolExecutor)GlobalSettings.getInstance().getWorkThreadPool()).getActiveCount());
		}
	}
	
	//[internal]下载完成或者异常从集合中删除
	public static void removeTask(KHttpData data){
		if(taskMap != null && data != null){
			taskMap.remove(data);	
		}
	}
}
