package com.cmmap.internal.driver.service;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.os.RemoteException;

import com.cmmap.internal.driver.service.IHttpService;
import com.cmmap.internal.mapcore.KHttpData;

/**
 * [internal]下载数据的service
 * @author liangz
 *
 */
public class HttpService extends Service {
	
	private class HttpServiceImpl extends IHttpService.Stub{

		private DownloadInvoke download;
		public HttpServiceImpl(){
			if(download == null){
				download = new DownloadInvoke();
			}
		}
		@Override
		public void post(KHttpData data) throws RemoteException {
			if(download != null){
				download.invoke(data);
			}
		}
		@Override
		public void close(KHttpData data) throws RemoteException {
			if(download != null){
				download.colseTask(data);
			}
		}
	}
	private HttpServiceImpl hsi_bind;
	@Override
	public void onCreate() {
		super.onCreate();
		hsi_bind = new HttpServiceImpl();
	}
	
	@Override
	public IBinder onBind(Intent arg0) {
		return hsi_bind;
	}

	@Override
	public void onDestroy() {
		super.onDestroy();
	}

}
