package com.cmmap.internal.driver.view;

import android.graphics.PointF;

import com.cmmap.internal.maps.KMapOptions;
import com.cmmap.internal.maps.model.KLatLng;

public class ViewContext {
	
	private PointF viewport;
	
	private KMapOptions mapOptions;
	/**
	 * [internal]位置
	 */
	private KLatLng latlon;
	/**
	 * [internal]描画的平行移动量
	 */
	private PointF translation;
	/** 
	 * [internal]比例尺
	 */
	private float level;
	/** 
	 * [internal]旋转角
	 */
	private float rotation;
	/** 
	 * [internal]样式
	 * 様式
	 */
	private String styleId;
	/** 
	 * [internal]俯仰角
	 */
	private float pitch;
	/** 
	 * [internal]地图的当前模式
	 */
	
//	public MotionEvent event;
	
	public ViewContext(KMapOptions options) {
		this.mapOptions = options;
		this.viewport = new PointF(400,800);
		latlon = new KLatLng(0, 0);
		translation = new PointF(0,0);
		level = 2;
		rotation = 0;
		styleId="";
		pitch = 0;
	}

	public void setViewport(PointF viewport) {
		this.viewport = viewport;
	}
	public void setViewport(int w ,int h){
		if (this.viewport == null) {
			this.viewport = new PointF(w,h);
		}
		else {
			this.viewport.x = w;
			this.viewport.y = h;
		}
		
	}

	public PointF getViewport() {
		return viewport;
	}

	public KMapOptions getMapOptions() {
		return mapOptions;
	}

	public void setMapParams(MapParams mapParams) {
		this.latlon = mapParams.getLatlon();
		this.translation = mapParams.getTranslation();
		this.level = mapParams.getLevel();
		this.rotation = mapParams.getRotation();
		this.styleId = mapParams.getStyleId();
		this.pitch = mapParams.getPitch();
	}

	public MapParams getMapParams() {
		return new MapParams(latlon, translation, level, rotation, styleId, pitch,viewport);
	}
}

