package com.cmmap.internal.mapcore;

import java.io.UnsupportedEncodingException;

public class ByteUlit {
	
	static int s_FACTO = 10000; 

	/**
	 * 通过byte数组取到int
	 * 
	 * @param bb
	 * @param kIndex 第几位开始
	 * @return
	 */
	/*
	public static int getInt4(byte[] bb, KInt kIndex) {
		int index = kIndex.IntVal();
		int iRet = (int) ((((bb[index + 3] & 0xff) << 24)
				| ((bb[index + 2] & 0xff) << 16)
				| ((bb[index + 1] & 0xff) << 8) | ((bb[index + 0] & 0xff) << 0)));
		index += 4;
		kIndex.PutVal(index);
		return iRet;
	}
	*/

	/**
	 * 转换int为byte数组
	 * 
	 * @param bb
	 * @param x
	 * @param kIndex
	 */
	/*
	public static void putInt4(byte[] bb, int x, KInt kIndex) {
		int index = kIndex.IntVal();
		bb[index + 3] = (byte) (x >> 24);
		bb[index + 2] = (byte) (x >> 16);
		bb[index + 1] = (byte) (x >> 8);
		bb[index + 0] = (byte) (x >> 0);
		index += 4;
		kIndex.PutVal(index);
	}
	*/

	/**
	 * 通过byte数组取到short
	 * 
	 * @param bb
	 * @param kIndex 第几位开始取
	 * @return
	 */
	public static int getShort2(byte[] bb, KInt kIndex) {
		int index = kIndex.IntVal();
		short sRet = (short) (((bb[index + 1] & 0xff) << 8) | (bb[index + 0] & 0xff));
		index += 2;
		kIndex.PutVal(index);
		return sRet;
	}

	/**
	 * 转换short为byte
	 * 
	 * @param b
	 * @param s 需要转换的short
	 * @param kIndex
	 */
	public static void putShort(byte b[], short s, KInt kIndex) {
		int index = kIndex.IntVal();
		b[index + 1] = (byte) (s >> 8);
		b[index + 0] = (byte) (s >> 0);
		index += 2;
		kIndex.PutVal(index);
	}

	/**
	 * 转换long型为byte数组
	 * 
	 * @param bb
	 * @param x
	 * @param kIndex
	 */
	public static void putLong(byte[] bb, long x, KInt kIndex) {
		int index = kIndex.IntVal();
		bb[index + 7] = (byte) (x >> 56);
		bb[index + 6] = (byte) (x >> 48);
		bb[index + 5] = (byte) (x >> 40);
		bb[index + 4] = (byte) (x >> 32);
		bb[index + 3] = (byte) (x >> 24);
		bb[index + 2] = (byte) (x >> 16);
		bb[index + 1] = (byte) (x >> 8);
		bb[index + 0] = (byte) (x >> 0);
		index += 8;
		kIndex.PutVal(index);
	}

	/**
	 * 通过byte数组取到long
	 * 
	 * @param bb
	 * @param kIndex
	 * @return
	 */
	public static long getLong(byte[] bb, KInt kIndex) {
		int index = kIndex.IntVal();
		long lRet = ((((long) bb[index + 7] & 0xff) << 56)
				| (((long) bb[index + 6] & 0xff) << 48)
				| (((long) bb[index + 5] & 0xff) << 40)
				| (((long) bb[index + 4] & 0xff) << 32)
				| (((long) bb[index + 3] & 0xff) << 24)
				| (((long) bb[index + 2] & 0xff) << 16)
				| (((long) bb[index + 1] & 0xff) << 8) | (((long) bb[index + 0] & 0xff) << 0));
		index += 8;
		kIndex.PutVal(index);
		return lRet;
	}

	/**
	 * 转换long型低4字节为byte数组 ，用于对应C++的4字节无符号数
	 * @param bb
	 * @param x
	 * @param kIndex
	 */
	public static void putLong4(byte[] bb, long x, KInt kIndex) {
		int index = kIndex.IntVal();
		if (x < 0)
		{
			x = 0x100000000L + x;
		}
		
		bb[index + 3] = (byte) (x >> 24);
		bb[index + 2] = (byte) (x >> 16);
		bb[index + 1] = (byte) (x >> 8);
		bb[index + 0] = (byte) (x >> 0);
		index += 4;
		kIndex.PutVal(index);
	}

	/**
	 * 通过4字节byte数组取到long ，用于对应C++的4字节无符号数
	 * 
	 * @param bb
	 * @param kIndex
	 * @return
	 */
	public static long getLong4(byte[] bb, KInt kIndex) {
		int index = kIndex.IntVal();
		long lRet = ((((long) bb[index + 3] & 0xff) << 24)
				| (((long) bb[index + 2] & 0xff) << 16)
				| (((long) bb[index + 1] & 0xff) << 8) | (((long) bb[index + 0] & 0xff) << 0));
		if (lRet >= 0x7FFFFFFF) {
			lRet = lRet - 0x100000000L;
		}
		index += 4;
		kIndex.PutVal(index);
		return lRet;
	}


	/**
	 * @param bb
	 * @param ch
	 * @param kIndex
	 */
	public static void putChar(byte[] bb, char ch, KInt kIndex) {
		int index = kIndex.IntVal();
		int temp = (int) ch;
		//[internal] byte[] b = new byte[2];
		for (int i = 0; i < 2; i++) {
			bb[index + i] = new Integer(temp & 0xff).byteValue(); //[internal] 将最高位保存在最低位
			temp = temp >> 8; //[internal] 向右移8位
		}
		index += 2;
		kIndex.PutVal(index);
	}


	/**
	 * 字节到字符转换
	 * @param b
	 * @param kIndex
	 * @return
	 */
	public static char getChar(byte[] b, KInt kIndex) {
		int index = kIndex.IntVal();
		int s = 0;
		if (b[index + 1] > 0) {
			s += b[index + 1];
		} else {
			s += 256 + b[index + 0];
		}
		s *= 256;
		if (b[index + 0] > 0) {
			s += b[index + 1];
		} else {
			s += 256 + b[index + 0];
		}
		char ch = (char) s;
		index += 2;
		kIndex.PutVal(index);
		return ch;
	}

	/**
	 * float转换byte
	 * @param bb
	 * @param x
	 * @param kIndex
	 */
	public static void putFloat(byte[] bb, float x, KInt kIndex) {
		int iInteger = (int)x;
		int iDecimals = (int)((x - iInteger) * s_FACTO);
		//System.out.println("*********putFloat**********");
		//System.out.println(iInteger);
		//System.out.println(iDecimals);
		putLong4(bb, iInteger, kIndex);
		putLong4(bb, iDecimals, kIndex);
	}

	/**
	 * 通过byte数组取得float
	 * @param b
	 * @param kIndex
	 * @return
	 */
	public static float getFloat(byte[] b, KInt kIndex) {
		int iInteger = (int)getLong4(b, kIndex);
		float fDecimals = ((float)getLong4(b, kIndex)) / s_FACTO;
		return (float)(iInteger + fDecimals);
	}

	/**
	 * double转换byte
	 * @param bb
	 * @param x
	 * @param kIndex
	 */
	public static void putDouble(byte[] bb, double x, KInt kIndex) {
		int iInteger = (int)x;
		int iDecimals = (int)((x - iInteger) * s_FACTO);
		putLong4(bb, iInteger, kIndex);
		putLong4(bb, iDecimals, kIndex);
	}

	/**
	 * 通过byte数组取得float
	 * @param b
	 * @param kIndex
	 * @return
	 */
	public static double getDouble(byte[] b, KInt kIndex) {
		int iInteger = (int)getLong4(b, kIndex);
		double dDecimals = ((double)getLong4(b, kIndex)) / s_FACTO;
		return (double)(iInteger + dDecimals);
	}

	/**
	 * 通过byte数组取到boolean
	 * @param bb
	 * @param kIndex 第几位开始
	 * @return
	 */
	public static boolean getboolean(byte[] bb, KInt kIndex) {
		int index = kIndex.IntVal();
		if (bb[index] != 0) {
			index += 1;
			kIndex.PutVal(index);
			return true;
		} else {
			index += 1;
			kIndex.PutVal(index);
			return false;
		}
	}

	/**
	 * 转换boolean为byte数组
	 * @param bb
	 * @param val
	 * @param kIndex
	 */
	public static void putboolean(byte[] bb, boolean val, KInt kIndex) {
		int index = kIndex.IntVal();
		bb[index] = (byte) (val ? 1 : 0);
		index += 1;
		kIndex.PutVal(index);
	}
	

	/**
	 * 转换stringi为byte数组
	 * @param bb
	 * @param str
	 * @param kIndex
	 */
	public static void SerializeString(byte[] bb, String str, KInt kIndex)
	{
		//System.out.println(str);
		byte [] bytes = null;
		try 
		{
			bytes = str.getBytes("UTF-8");
		} 
		catch (UnsupportedEncodingException e) 
		{
			e.printStackTrace();
		}  
		
		if(bytes != null)
		{
			int iStrSize = bytes.length;
			putLong4(bb, iStrSize, kIndex); // 4 bytes
			int index = kIndex.IntVal();
			System.arraycopy(bytes, 0, bb, index, iStrSize);
			//System.out.println(index);
			//System.out.println(iStrSize);
			index += iStrSize;
			kIndex.PutVal(index);
		}
		
	}
	
	/**
	 * 转换stringi为byte数组
	 * @param bb
	 * @param kIndex
	 */
	public static String DerializeString(byte[] bb, KInt kIndex)
	{
		int iSize = (int)getLong4(bb, kIndex);
		int index = kIndex.IntVal();
		//System.out.println(index);

		//System.out.println(iSize);
		byte [] bytes = new byte[iSize];
		
		System.arraycopy(bb, index, bytes, 0, iSize);
		index += iSize;
		String strRet = "";
		try 
		{
			strRet = new String(bytes, "UTF-8");
		} 
		catch (UnsupportedEncodingException e) 
		{
			e.printStackTrace();
		}
		kIndex.PutVal(index);
		return strRet;
	}
	
	public static String DerializeGBKString(byte[] bb, KInt kIndex)
    {
        int iSize = (int)getLong4(bb, kIndex);
        int index = kIndex.IntVal();
        //System.out.println(index);

        //System.out.println(iSize);
        byte [] bytes = new byte[iSize];
        
        System.arraycopy(bb, index, bytes, 0, iSize);
        index += iSize;
        String strRet = "";
        try 
        {
            strRet = new String(bytes, "GBK");
        } 
        catch (UnsupportedEncodingException e) 
        {
            e.printStackTrace();
        }
        kIndex.PutVal(index);
        return strRet;
    }
}
