package com.cmmap.internal.mapcore;

import java.util.concurrent.atomic.AtomicInteger;

import android.graphics.Bitmap;

public class KBitmap
{
	private static final AtomicInteger mID = new AtomicInteger();
	
	public static int mallocId() {
		return mID.incrementAndGet();
	}
	
	public static synchronized void add(int id, Bitmap bitmap, int is_revert)
	{
		addBitmapNative(bitmap, id, is_revert);
	}
	
	public static synchronized void remove(int id)
	{
		addBitmapNative(null, id, 0);
	}
	
	private static native int addBitmapNative(Object bitmap, int id, int is_revert);

	static {
		System.loadLibrary("cmmap");
	}
}
