package com.cmmap.internal.mapcore;


public class KGEOCOORD {
	/**
	 * A kn_ulong value that specifies the absolute longitude of a map object.
	 * The unit of this value is 1/1024 second.
	 */
	public long lLongitude;
	/**
	 * A kn_ulong value that specifies the absolute latitude of a map object.
	 * The unit of this value is 1/1024 second.
	 */
	public long lLatitude;

	public KGEOCOORD() {
		lLongitude = 0;
		lLatitude = 0;
	}

	public KGEOCOORD(long lLon, long lLat) {
		lLongitude = lLon;
		lLatitude = lLat;
	}

	public void ChangeTo256() {
		lLongitude = (lLongitude + 40 * 3600 * 1024) / 4;
		lLatitude = lLatitude / 4;
	}

	public void ChangeTo1024() {
		lLongitude = lLongitude * 4 - (40 * 3600 * 1024);
		lLatitude = lLatitude * 4;
	}

	/**
	 * 取序列化的字节数
	 */
	int getSize() {
		return 8;
	}

	byte[] Serialize(byte[] pBuf, KInt iIndex) {
		ByteUlit.putLong4(pBuf, lLongitude, iIndex);
		ByteUlit.putLong4(pBuf, lLatitude, iIndex);
		return pBuf;
	}

	KGEOCOORD Derialize(byte[] pBuf, KInt iIndex) {
		lLongitude = ByteUlit.getLong4(pBuf, iIndex);
		lLatitude = ByteUlit.getLong4(pBuf, iIndex);
		return this;
	}
	
	@Override
	public boolean equals(Object o) {
		if (o == null || !(o instanceof KGEOCOORD)) {
			return false;
		}
		
		KGEOCOORD crd = (KGEOCOORD) o;
		return lLatitude == crd.lLatitude
				&& lLongitude == crd.lLongitude;
	}
}
