package com.cmmap.internal.mapcore;

import android.os.Parcel;
import android.os.Parcelable;


public class KHttpData implements Parcelable{
	
	public KHttpData(){
		m_data_type = REQ_EMPTY;
		m_Rect = new KRect();
	}
	
	@Override
	public int hashCode() {
		int result = 17;
		result = 31 * result + m_data_type;
		if (m_Rect != null){
			 result = 31 * result + m_Rect.hashCode();
		}
		return result;
	}
	
	@Override
	public boolean equals(Object o) {
		boolean bRet = false;
		if(o != null && o instanceof KHttpData){
			KHttpData data = (KHttpData) o;
			if(m_data_type == data.m_data_type) {
				if(m_data_type == REQ_PCLDATA) {
					bRet = m_Rect.equals(data.m_Rect) && m_iLevel == data.m_iLevel && (m_iDivIndex == data.m_iDivIndex);
				}
				else if(m_data_type == REQ_TILE) {
					// 卫片参数在url中，需要比较url
					bRet = m_str_url.equals(data.m_str_url);
				}
				else if(m_data_type == REQ_PCLMLT) {
					//	多Parcel请求
					bRet = m_str_url.equals(data.m_str_url);
				}
				else if (m_data_type == REQ_OVERLAY_TILE) {
					bRet = (m_Rect.equals(data.m_Rect) && m_iLevel == data.m_iLevel);
				}
				else {
					bRet = true;
				}
			}
			return bRet;
		}
		return bRet;
	}
	
	public final static int REQ_EMPTY = 0;
	public final static int REQ_VERSION = 1;
	public final static int REQ_MAPBASE = 2;
	public final static int REQ_PCLBASE = 3;
	public final static int REQ_PCLDATA = 4;
	public final static int REQ_PCLMLT = 5;
	public final static int REQ_POLYGON = 6;
	public final static int REQ_LANDMARK = 7;
	public final static int REQ_TILE = 8;	
	public final static int REQ_OVERLAY_TILE = 9;
	
	public int m_data_type;
    //KLoadInfo_PTR 
    public int m_iLevel;
    public KRect m_Rect;
    public short m_iDivIndex;
    public String m_str_url;
    public byte[] m_body;		//body

	public int m_idata_size;	//请求到的网络数据的Size
    public byte[] m_data;		//网络数据实体
    /**
	* 取序列化的字节数
	*/
	int getSize() {
		if (m_data == null )
			return 0;
		else
		{
			return m_idata_size;
		}
	}
	
	@Override
	public int describeContents() {
		return 0;
	}
	@Override
	public void writeToParcel(Parcel dest, int flags) {
		Lg.e("zhuliang", "KHttpData writeToParcel start");
		dest.writeValue(m_data_type);
		dest.writeInt(m_iLevel);
		dest.writeValue(m_Rect);
		dest.writeString(m_str_url);
		dest.writeInt(m_idata_size);
		dest.writeByteArray(m_data);
		Lg.e("zhuliang", "KHttpData writeToParcel end");
	}
	
	private KHttpData(Parcel source){
		Lg.e("zhuliang", "KHttpData start");
		m_data_type = source.readInt();
		m_iLevel = source.readInt();
		m_Rect = (KRect) source.readValue(KRect.class.getClassLoader());
		m_str_url = source.readString();
		m_idata_size = source.readInt();
		source.readByteArray(m_data);
		Lg.e("zhuliang", "KHttpData end");
	}
	
    public static final Parcelable.Creator<KHttpData> CREATOR = new Parcelable.Creator<KHttpData>() {  
  
        @Override  
        public KHttpData createFromParcel(Parcel source) {  
            return new KHttpData(source);  
        }  
  
        @Override  
        public KHttpData[] newArray(int size) {  
            return new KHttpData[size];  
        }  
    };
    
	public void release() {
		m_body = null;
		m_data = null;
		m_Rect = null;
		m_str_url = null;
	}  
}
