package com.cmmap.internal.mapcore;

import java.io.UnsupportedEncodingException;
import java.nio.ByteBuffer;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;
import java.util.concurrent.ConcurrentHashMap;

import android.annotation.SuppressLint;
import android.graphics.Point;
import android.location.Location;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import com.cmmap.api.maps.model.LatLngBounds;
import com.cmmap.api.maps.model.MyTrafficStyle;
import com.cmmap.internal.driver.base.GlobalSettings;
import com.cmmap.internal.driver.base.HttpTool;
import com.cmmap.internal.driver.base.MapTool;
import com.cmmap.internal.driver.broadcastReceiver.NetWorkMonitorReceiver;
import com.cmmap.internal.driver.broadcastReceiver.NetWorkMonitorReceiver.NET_TYPE;
import com.cmmap.internal.driver.gesture.MapGestureManager;
import com.cmmap.internal.maps.KCameraUpdate;
import com.cmmap.internal.maps.model.KCameraPosition;
import com.cmmap.internal.maps.model.KLatLng;
import com.cmmap.internal.maps.model.KPoi;
import com.cmmap.internal.maps.model.MyLocationStyle;


//[internal]***************************Define Operation ID********************
@SuppressLint("NewApi")

public class MapCore {
	static int APITYPE_Initialize = 1;
	static int APITYPE_SaveUserData = 2;
	static int APITYPE_Refresh = 3;
	static int APITYPE_SetMapViewport = 4;
	static int APITYPE_GetMapViewport = 5;
	static int APITYPE_ScreenPointToCoord = 6;
	static int APITYPE_CoordToScreenPoint = 7;
	static int APITYPE_SetCoordArea = 8;
	static int APITYPE_SetDPI = 9;
	static int APITYPE_SetConfiguration = 10;
	static int APITYPE_GetConfiguration = 11;
	static int APITYPE_SetMapDispMode = 12;
	static int APITYPE_GetMapDispMode = 13;
	static int APITYPE_SetMapDrawMode = 14;
	static int APITYPE_GetMapDrawMode = 15;
	static int APITYPE_SetMapScaleValue = 16;
	static int APITYPE_GetMapScaleValue = 17;
	static int APITYPE_GetScaleLevelMapping = 18;
	static int APITYPE_SetMapScaleLevel = 19;
	static int APITYPE_GetMapScaleLevel = 20;
	static int APITYPE_SetMaxScale = 21;
	static int APITYPE_GetMaxScale = 22;
	static int APITYPE_SetMinScale = 23;
	static int APITYPE_GetMinScale = 24;
	static int APITYPE_SetMapCenter = 25;
	static int APITYPE_GetMapCenter = 26;
	static int APITYPE_MoveToScreenPt = 27;
	static int APITYPE_GetMapScaleMeterPixel = 28;
	static int APITYPE_AddUserShape = 29;
	static int APITYPE_UpdateUserShape = 33;
	static int APITYPE_DelUserShape = 34;
	static int APITYPE_SetNetworkData = 35;
	static int APITYPE_SetCachePath = 36;
	static int APITYPE_ClearCache = 37;
	static int APITYPE_GetCurCacheSize = 38;
	static int APITYPE_InitializeRender = 39;
	//static int APITYPE_SetTranslation = 40;
	static int APITYPE_GetServiceUrl = 41;
	static int APITYPE_SetEnableCache = 42;
	static int APITYPE_GetEnableCache = 43;
	static int APITYPE_SetMaxSize = 44;
	static int APITYPE_GetMaxSize = 45;
	static int APITYPE_GetStorageType = 46;
	static int APITYPE_GetCacheStorageUsageHint = 47;
	static int APITYPE_JniLOG = 48;
	//static int APITYPE_GetTranslation = 49;
	static int APITYPE_GetDataVersion = 50;	
	static int APITYPE_UpdateRTICData = 51;
	static int APITYPE_GetScalePerPixel = 52;

	static int APITYPE_SetMapRoute = 54;
	static int APITYPE_SetMapGuideInfo = 55;
	static int APITYPE_ClearMapRoute = 56;
	static int APITYPE_ClearMapGuideInfo = 57;
	
	
	
	static int APITYPE_SetLocLayerEnable = 58;
	static int APITYPE_GetLocLayerEnable = 59;
	static int APITYPE_SetLocationStyle = 60;
	static int APITYPE_GetLocationStyle = 61;
	static int APITYPE_SetTrafficStyle = 62;
	static int APITYPE_GetTrafficStyle = 63;
	static int APITYPE_SetMapTextZIndex = 64;
	static int APITYPE_GetMapTextZIndex = 65;
	static int APITYPE_UpDateCamera = 66;
	static int APITYPE_SetLocation = 67;
	static int APITYPE_SetSensorAngle = 68;
	static int APITYPE_OverViewMap = 69;
	static int APITYPE_SelectPOI = 70;
	
	static int APITYPE_SetRTICUse = 71;
	static int APITYPE_GetRTICUse = 72;
	static int APITYPE_SetEventUse = 73;
	static int APITYPE_GetEventUse = 74;
	
	static int APITYPE_StandardToLocatePosition = 80;
	static int APITYPE_CalcDistance = 81;
	static int APITYPE_GetAddressCode = 82;
	static int APITYPE_SetTileUrl = 83;
	static int APITYPE_OverViewMapEx = 84;
	static int APITYPE_ZoomInAndKeepingScreenRelativePosition = 85;
	static int APITYPE_GetMapRotateCenter = 86;
		
	static int APITYPE_GetMapScope = 87;
	static int APITYPE_GetMaxMapScope = 88;
	static int APITYPE_CalcPixelZoom = 89;
	static int APITYPE_GetNet = 90;
	static int APITYPE_SetNet = 91;
	static int APITYPE_SetFastRefreshMap = 92;
	static int APITYPE_IsPtInPoly = 93;
	static int APITYPE_SetMapSwitch = 94;
	static int APITYPE_GetMapSwitch = 95;
	static int APITYPE_SelectPolyline = 96;
	static int APITYPE_SetNetworkStatus = 97;
	static int APITYPE_GetSDKVersion = 98;
	static int APITYPE_ClearTileCache = 99;
	static int APITYPE_SetAuthInfo = 100;
	static int APITYPE_SetRunType = 101;
	static int APITYPE_OverViewMapExFree = 102;

	static int APITYPE_GetMaxScaleValue = 103;
	static int APITYPE_GetMinScaleValue = 104;
	static int APITYPE_OnOverLayClick = 105;
	static int APITYPE_UpdateUserShapeParam = 106;
	static int APITYPE_GetMapContentApprovalNumber = 107;
	static int APITYPE_SetTextSizeZoomRate = 108;
	
//[internal]****************************************************************/	
	
//[internal]***************Define enum**************************************
	
	/*Map Refresh Message*/
	public enum NAVI_MessageType
	{
		KMESSAGE_MP_REFRESH_MAP(30001);		//[internal]地图刷新消息
	    private int _value;
		private NAVI_MessageType(int value)
		{
			_value = value;
		}	
		public int value()
		{
			return _value;
		}
	};
	
	/*The Operation ID of Deleting the Shapes*/
	public enum NE_UserShape_DelRule
	{
		NE_UserShape_ALL(0),			//[internal]删除所有，不考虑ID参数
		NE_UserShape_ALLCircle(1),		//[internal]删除所有注册线，不考虑ID参数
		NE_UserShape_AllLine(2),		//[internal]删除所有注册线，不考虑ID参数
		NE_UserShape_AllPolygon(3),		//[internal]删除所有注册多边形，不考虑ID参数
		NE_UserShape_IDs(4),			//[internal]删除ID存在于param列表的usershape
		NE_UserShape_Not_IDs(5),		//[internal]删除ID不在param中的usershape
		NE_UserShape_Zindex(6),			//[internal]删除zindex在param列表中的usershape
		NE_UserShape_Not_Zindex(7);		//[internal]删除zindex不在param列表中的usershape
		
	    private int _value;
		private NE_UserShape_DelRule(int value)
		{
			_value = value;
		}
		
		public int value()
		{
			return _value;
		}
	};
	
	/*The Map Params*/
	public enum NE_MapParam_Object
	{   
		NE_Map_MapCenterCursor(0),		//[internal]地图中心光标当前是否显示
		NE_Map_Text(1),          		//[internal]是否显示文字
		NE_Map_TextSize(2),				//[internal]设置地图文字大小：小中大
		NE_Map_ShowMap(3),				//[internal]是否显示地图画面
		NE_Map_Theme(4),				//[internal]地图主题
		NE_Map_PitchAngle(5),			//[internal]俯仰角度
		NE_Map_RotateAngle(6),			//[internal]旋转角度
		NE_Map_LocType(7);
		
	    private int _value;
		private NE_MapParam_Object(int value)
		{
			_value = value;
		}
			
		public int value()
		{
			return _value;
		}
    }
	
	/*The LOG Type*/
	public enum NE_LOG_TYPE
	{   
		NE_LLL_ERR(0),              //[internal]For Error
		NE_LLL_WARN(1),             //[internal]For Warning
		NE_LLL_NOTICE(2),           //[internal]For Notice
		NE_LLL_INFO(3),             //[internal]For Infomation
		NE_LLL_DEBUG(4),            //[internal]Write when the status is Debug
		NE_LLL_VERBOSE(5);
		
	    private int _value;
		private NE_LOG_TYPE(int value)
		{
			_value = value;
		}
			
		public int value()
		{
			return _value;
		}
		
    }
	
	public enum MP_ENUM_SWITCH
	{
		MP_SHOW_BUILDING(0), 
		MP_SHOW_TEXT(1),
		MP_SHOW_SKY(2);
		
		private int _value;
		private MP_ENUM_SWITCH(int value)
		{
			_value = value;
		}
			
		public int value()
		{
			return _value;
		}
	}

	private static Map<KHttpData, java.util.Date> m_lst_httpReq = new HashMap<KHttpData, java.util.Date>();
	
	static boolean FindReq(KHttpData req) {
		boolean ret = false;
		java.util.Date cur = new java.util.Date();
		java.util.Date date = m_lst_httpReq.get(req);
		if(date != null) {
			if(cur.getTime() - date.getTime() < 1000 * 10) {
				ret = true;
			}
			else {
				m_lst_httpReq.remove(req);
				m_lst_httpReq.put(req, cur);
			}
		}
		else {
			m_lst_httpReq.put(req, cur);
		}
		return ret;
	}
	
/**
 * Initialize the Program
 * @Return  0:Success 1:Failed
 * @param resPath: The Resource Path,Read Only
 * @param dataPath: The Map Data Path,Read Only
 * @param savPath: A Path which is able to Write
 * **/	
	public static int initialize(String resPath, String dataPath, String savPath)
	{
		registerCallback();
		
		byte [] bytesres = null;
		byte [] bytesdata = null;
		byte [] bytessav = null;
		byte [] byteModel = null;
		try 
		{
			bytesres = resPath.getBytes("UTF-8");
			bytesdata = dataPath.getBytes("UTF-8");
			bytessav = savPath.getBytes("UTF-8");
			byteModel = android.os.Build.MODEL.getBytes("UTF-8");
		} 
		catch (UnsupportedEncodingException e) 
		{
			e.printStackTrace();
		} 
		//[internal]字符串长度和字符串Buffer
		int iBufSize = bytesres.length + bytesdata.length + bytessav.length + byteModel.length + 16;
		byte[] pBuf = new byte[iBufSize];
		KInt iIndex = new KInt(0);
		ByteUlit.SerializeString(pBuf, resPath, iIndex);
		ByteUlit.SerializeString(pBuf, dataPath, iIndex);
		ByteUlit.SerializeString(pBuf, savPath, iIndex);
		ByteUlit.SerializeString(pBuf, android.os.Build.MODEL, iIndex);

		int iRet = MapJni.JNIAPI(APITYPE_Initialize, iBufSize, pBuf);
			
		Log.d("MapJni", "APITYPE_Initialize  = " + iRet);
		
		return iRet;
	}
	
/**
 * Save The Userdata
 * @Return int 0:Success 1:Failed
 * @param
 * **/	
	public static int saveUserData()
	{
		int iRet = MapJni.JNIAPI(APITYPE_SaveUserData, 0, null);
		return iRet;
	}

/**
 * Refresh Map
 * @param refreshStatusValid 
 * @Return int 0:Success 1:Failed
 * @param 
 * **/	
	public static int refresh(boolean refreshStatusValid, int debugMask)
	{
		byte[] pBuf = new byte[512];
		KInt iIndex = new KInt(0);
		ByteUlit.putboolean(pBuf, refreshStatusValid, iIndex);
		ByteUlit.putLong4(pBuf, debugMask, iIndex);
		MapJni.JNIAPI(APITYPE_Refresh, iIndex.IntVal(), pBuf);
		iIndex.PutVal(0);
		boolean refreshStatus = ByteUlit.getboolean(pBuf, iIndex);
		return refreshStatus ? 1 : 0;
	}

	
/**
 * Set Map Viewport
 * @Return int 0:Success 1:Failed
 * @param IN rect: Viewport
 * **/		
	public static int setMapViewport(KRect rect, int w, int h, float dpi_x, float dpi_y, boolean is_landscape)
	{	
		int iSize = rect.getSize();
		byte[] pBuf = new byte[512];
		KInt iIndex = new KInt(0);
		rect.Serialize(pBuf, iIndex);
		
		ByteUlit.putLong4(pBuf, w, iIndex);
		ByteUlit.putLong4(pBuf, h, iIndex);
		
		ByteUlit.putFloat(pBuf, dpi_x, iIndex);
		ByteUlit.putFloat(pBuf, dpi_y, iIndex);
		
		int i_is_landscapre = is_landscape? 1:0;
		ByteUlit.putLong4(pBuf, i_is_landscapre, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_SetMapViewport, iIndex.IntVal(), pBuf );
		return iRet;
	}

/**
 * Get Map Viewport
 * @Return int 0:Success 1:Failed
 * @param OUT rect: Viewport
 * **/	
	public static int GetMapViewport(KRect rect)
	{
		int iSize = rect.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetMapViewport, iSize, pBuf);
		
		rect.Derialize(pBuf, iIndex);
        return iRet;
	}
	
/**
 * Switch Screen Point To Coord
 * @Return int 0:Success 1:Failed
 * @param IN cPointScreen: Screen Point
 * @param OUT cPointCoord: Point Coord
 * **/	
	public static int ScreenPointToCoord(KPoint cPointScreen,KGEOCOORD cPointCoord)
	{	
		int iSize = cPointScreen.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		cPointScreen.Serialize(pBuf,iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_ScreenPointToCoord, iSize, pBuf);

		iIndex = new KInt(0);
		cPointCoord.Derialize(pBuf,iIndex);	
		
        return iRet;
	}
	
/**
 * Switch Coord To Screen Point
 * @Return int 0:Success 1:Failed
 * @param IN cPointCoord: Point Coord 
 * @param OUT cPointScreen: Screen Point
 * **/		
	public static int CoordToScreenPoint(KGEOCOORD cPointCoord,KPoint cPointScreen)
	{
		int iSize = cPointCoord.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		//System.out.println("before cPoint");
		//System.out.println(cPointCoord.lLongitude);
		//System.out.println(cPointCoord.lLatitude);
		
		cPointCoord.Serialize(pBuf,iIndex);
	
		int iRet = MapJni.JNIAPI(APITYPE_CoordToScreenPoint, iSize, pBuf);
		
	    iIndex = new KInt(0);
		cPointScreen.Derialize(pBuf,iIndex); 	
		
		//System.out.println("after cPoint");
		//System.out.println(cPointScreen.iX);
		//System.out.println(cPointScreen.iY);
		
	    return iRet;
	}

/**
 * Set Coord Area
 * @Return int 0:Success 1:Failed
 * @param IN coordArea: Coord Area
 * @param IN screenArea: Screen Area
 * @param IN scaleLevel: Scale Level
 * @param IN crd: Coord
 * **/		
	public static int SetCoordArea(KRect coordArea, KRect screenArea, KFloat scaleLevel, KGEOCOORD crd)
	{
		int iSize = coordArea.getSize() + screenArea.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		coordArea.Serialize(pBuf,iIndex);
		screenArea.Serialize(pBuf, iIndex);
		
        int iRet = MapJni.JNIAPI(APITYPE_SetCoordArea, iSize, pBuf);
		
        iIndex.PutVal(0);
		scaleLevel.PutVal(19 - ByteUlit.getFloat(pBuf, iIndex)); 
		crd.Derialize(pBuf,iIndex);

	    return iRet;
	}
	
/**
 * Set DPI
 * @Return int 0:Success 1:Failed
 * @param IN fDPI: DPI
 * **/		
	public static int SetDPI(float fDPI)
	{
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		ByteUlit.putFloat(pBuf, fDPI, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_SetDPI, iSize, pBuf);		
		return iRet;
	}

/**
 * Set Configuration
 * @Return int 0:Success 1:Failed
 * @param IN eObject: Map Operation
 * @param IN dwValue: Configuration Value
 * **/	
	public static int SetConfiguration(NE_MapParam_Object eObject, float dwValue)
	{
		int iSize = 12;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, eObject._value, iIndex);
		ByteUlit.putFloat(pBuf, dwValue, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_SetConfiguration, iSize, pBuf);
	    return iRet;
	}

/**
 * Get Configuration
 * @Return int 0:Success 1:Failed
 * @param IN iMapType: Map Type
 * @param OUT myclValue: Configuration Value
 * **/		
	public static int  GetConfiguration(int iMapType,KFloat myclValue)
	{
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, iMapType, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetConfiguration, iSize, pBuf);
		
		iIndex = new KInt(0);
		myclValue.PutVal(ByteUlit.getFloat(pBuf, iIndex)); 
		return iRet;
	}
	
/**
 * Set Map Display Mode
 * @Return int 0:Success 1:Failed
 * @param IN iDispMode: Display Mode, 0: 2D 1: 3D
 * **/	
/*
	public static int SetMapDispMode(int iDispMode)
	{
		int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, iDispMode, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_SetMapDispMode, iSize, pBuf);	
		return iRet;
	}
*/

/**
 * Set Map Display Mode
 * @Return int 0:Success 1:Failed
 * @param IN iDispMode: Display Mode, 0: 2D 1: 3D
 * **/	
/*	public static int GetMapDispMode(KInt dispMode)
	{
		int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetMapDispMode, iSize, pBuf);	
		dispMode.PutVal(ByteUlit.getLong4(pBuf, iIndex));
		return iRet;
	}
	*/
/**
 * Set Map Draw Mode
 * @Return  0:Success 1:Failed
 * @param  iDrawMode: Draw Mode, 0: Normal Refresh 1: Fast Refresh
 * **/		
	public static int SetMapDrawMode(int iDrawMode)
	{
		int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, iDrawMode, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_SetMapDrawMode, iSize, pBuf);	
		return iRet;
	}

/**
 * GetMapDrawMode
 * @Return  0:Success 1:Failed
 * @param  drawMode: Draw Mode, 0: Normal Refresh 1: Fast Refresh
 * **/	
	public static int GetMapDrawMode(KInt drawMode)
	{
		int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetMapDrawMode, iSize, pBuf);	
		drawMode.PutVal(ByteUlit.getLong4(pBuf, iIndex));
		return iRet;
	}
	
/**
 * Set Map Scale Value
 * @Return  0:Success 1:Failed
 * @param  iValue: Scale Value 	
 * **/	
	public static int SetMapScaleValue(int iValue,boolean no_draw)
	{
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, iValue, iIndex);
		ByteUlit.putboolean(pBuf, no_draw, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_SetMapScaleValue, iSize, pBuf);	
		return iRet;
	}
	
	/**
	 * Set Map Scale Value
	 * @Return  0:Success 1:Failed
	 * @param  iValue: Scale Value 	
	 * **/	
	public static int SetFastRefreshMap(boolean enable)
	{
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putboolean(pBuf, enable, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_SetFastRefreshMap, iSize, pBuf);
		return iRet;
	}

	/**
	 * Get Map Scale Value
	 * @Return  0:Success 1:Failed
	 * @param  iValue: Scale Value 	
	 * **/	
	public static int GetMapScaleValue(KInt iValue)
	{
		int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetMapScaleValue, iSize, pBuf);	
		
		iValue.PutVal(ByteUlit.getLong4(pBuf, iIndex));

		return iRet;
	}
	
	public static int GetMapScope(KInt w, KInt h)
	{
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetMapScope, iSize, pBuf);	
		
		w.PutVal(ByteUlit.getLong4(pBuf, iIndex));
		h.PutVal(ByteUlit.getLong4(pBuf, iIndex));
		
		return iRet;
	}	
	
	public static void GetMaxMapScope(KRect rect)
	{
		int iSize = 16;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		MapJni.JNIAPI(APITYPE_GetMaxMapScope, iSize, pBuf);	
		
		rect.iLeft 		= ByteUlit.getLong4(pBuf, iIndex);
		rect.iTop 		= ByteUlit.getLong4(pBuf, iIndex);
		rect.iRight 	= ByteUlit.getLong4(pBuf, iIndex);
		rect.iBottom 	= ByteUlit.getLong4(pBuf, iIndex);
	}
	
/**
 * GetMapScaleLevelMapping
 * @Return  0:Success 1:Failed
 * @param  myScaleProp: vector of NE_ScaleProp
 * **/		
	public static int GetMapScaleLevelMapping(Vector<NE_ScaleProp> myScaleProp)
	{
		int iBuffersize = 1024;
		byte[] pBuffer = new byte[iBuffersize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetScaleLevelMapping, iBuffersize, pBuffer);
		int ivSize = (int) ByteUlit.getLong4(pBuffer, iIndex);
		
		for(int k = 0; k < ivSize;  k++ )
		{
			NE_ScaleProp tmp = new NE_ScaleProp();

			tmp.m_scale_level = (int)ByteUlit.getLong4(pBuffer, iIndex);
			
			tmp.m_scale_value = (int)ByteUlit.getLong4(pBuffer, iIndex);
			
			tmp.m_scale_distance = (int)ByteUlit.getLong4(pBuffer, iIndex);
			
			tmp.m_scale_Name = ByteUlit.DerializeString(pBuffer, iIndex);
			
			tmp.iSize = 12 + (tmp.m_scale_Name).length();
			
			myScaleProp.add(tmp);
		}
		return iRet;
	}

/**
 * SetMapScaleLevel
 * @Return  0:Success 1:Failed
 * @param  fLevel: Map Scale Level
 * **/
	public static int SetMapScaleLevel(float fLevel)
	{
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		fLevel = 19 - fLevel;
		ByteUlit.putFloat(pBuf, fLevel, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_SetMapScaleLevel, iSize, pBuf);
		return iRet;
	}

/**
 * GetMapScaleLevel
 * @Return  0:Success 1:Failed
 * @param  fLevel: Map Scale Level
 * **/	
	public static int GetMapScaleLevel(KFloat fLevel)
	{
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetMapScaleLevel, iSize, pBuf);	
		
		fLevel.PutVal(ByteUlit.getFloat(pBuf, iIndex));
		//客户比例尺 :  19-3  0-16
		fLevel.PutVal(19 - fLevel.FloatVal());
		return iRet;
	}

/**
 * SetMaxScale
 * @Return  0:Success 1:Failed
 * @param  iScale: Max Scale
 * **/	
	public static int SetMaxScale(int iScale)
	{
		int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, 19 - iScale, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_SetMinScale, iSize, pBuf);	
		return iRet;
	}
	
/**
 * SetMaxScale
 * @Return  Max Scale
 * **/	
	public static int GetMaxScale()
	{
		int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		MapJni.JNIAPI(APITYPE_GetMinScale, iSize, pBuf);
		return 19 - (int)ByteUlit.getLong4(pBuf, iIndex);
	}

/**
 * SetMinScale
 * @Return  0:Success 1:Failed
 * @param  iScale: Min Scale
 * **/		
	public static int SetMinScale(int iScale)
	{
		int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, 19 - iScale, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_SetMaxScale, iSize, pBuf);	
		return iRet;
	}

/**
 * GetMinScale
 * @Return  Min Scale
 * **/	
	public static int GetMinScale()
	{
		int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		MapJni.JNIAPI(APITYPE_GetMaxScale, iSize, pBuf);
		return 19 - (int)ByteUlit.getLong4(pBuf, iIndex);
	}

/**
 * SetMapCenter
 * @Return  0:Success 1:Failed
 * @param  ulLongitude: Longitude
 * @param  ulLatitude: Latitude
 * **/		
	public static int SetMapCenter(long ulLongitude,long ulLatitude )
	{
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		//[internal]put ulLongitude
		ByteUlit.putLong4(pBuf, ulLongitude, iIndex);
		
		//[internal]put ulLongitude
		ByteUlit.putLong4(pBuf, ulLatitude, iIndex);
        
		int iRet = MapJni.JNIAPI(APITYPE_SetMapCenter, iSize, pBuf);
		return iRet;
	}

/**
 * GetMapCenter
 * @Return  0:Success 1:Failed
 * @param  mapCenterParam: Map Center Coord
 * **/		
	public static int GetMapCenter(KGEOCOORD mapCenterParam ) 
	{
		int iSize = mapCenterParam.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
	
        int iRet = MapJni.JNIAPI(APITYPE_GetMapCenter,iSize, pBuf);	
        
        mapCenterParam.Derialize(pBuf, iIndex);
    
		return iRet;
	}

/**
 * MoveToScreenPt
 * @Return  0:Success 1:Failed
 * @param  x: x Coord
 * @param  y: y Coord
 * **/		
    public static int MoveToScreenPt(int x,int y,boolean no_draw)
	{
    	int iSize = 12;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
        ByteUlit.putLong4(pBuf, x, iIndex);
        ByteUlit.putLong4(pBuf, y, iIndex);
        ByteUlit.putboolean(pBuf, no_draw, iIndex);
        
        int iRet = MapJni.JNIAPI(APITYPE_MoveToScreenPt,iSize, pBuf);	
		return iRet;
	}

/**
 * GetMapScaleMeterPixel
 * @Return 0:Success 1:Failed
 * @param pixelLen: pixel Length
 * @param scaleName: scale Name
 * **/	
	public static int GetMapScaleMeterPixel(KInt pixelLen, String scaleName)
	{
		KInt iIndex = new KInt(0);

		int iBufferSize = 1024;
		
		byte[] pBuffer = new byte[iBufferSize];
		int iRet = MapJni.JNIAPI(APITYPE_GetMapScaleMeterPixel, iBufferSize, pBuffer);
		
		scaleName = ByteUlit.DerializeString(pBuffer, iIndex);
		pixelLen.PutVal(ByteUlit.getLong4(pBuffer, iIndex));
	    
		return iRet;
	}

/**
 * AddUserShape
 * @Return int 0:Success 1:Failed
 * @param shape: MapOverLayShapeCircle
 * **/
	public static int AddUserShape(MapOverLayShapeCircle shape)
	{
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_AddUserShape,pBuf.length, pBuf);	
		return iRet;
	}

/**
 * AddUserShape
 * @Return int 0:Success 1:Failed
 * @param shape: MapOverLayShapePolygon
 * **/
	public static int AddUserShape(MapOverLayShapePolygon shape)
	{
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_AddUserShape,pBuf.length, pBuf);	
		return iRet;
	}

/**
 * AddUserShape
 * @Return int 0:Success 1:Failed
 * @param IN shape: MapOverLayShapePolyLine
 * **/	
	public static int AddUserShape(MapOverLayShapePolyLine shape)
	{
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_AddUserShape,pBuf.length, pBuf);	
		return iRet;
	}

/**
 * AddUserShape
 * @Return int 0:Success 1:Failed
 * @param IN shape: MapOverLayShapeVicsLine
 * **/	
	public static int AddUserShape(MapOverLayShapeArc shape)
	{
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_AddUserShape,pBuf.length, pBuf);	
		return iRet;
	}
/**
 * AddUserShape
 * @Return int 0:Success 1:Failed
 * @param IN shape: MapOverLayShapePoint
 * **/	
	public static int AddUserShape(MapOverLayShapeGround shape)
	{
		int iSize = shape.getSize();
		if (iSize == 0)
		{
			return 1;
		}
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_AddUserShape,pBuf.length, pBuf);	
		return iRet;
	}
	
	public static int AddUserShape(MapOverLayShapePoints shape) {
		int iSize = shape.getSize();
		if (iSize == 0)
		{
			return 1;
		}
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_AddUserShape,pBuf.length, pBuf);	
		return iRet;
	}
	
/**
 * UpdateUserShape
 * @Return  0:Success 1:Failed
 * @param shape: MapOverLayShapeCircle
 * **/		
	public static int UpdateUserShape(MapOverLayShapeCircle shape)
	{
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_UpdateUserShape,pBuf.length, pBuf);	
		return iRet;
	}
	
/**
 * UpdateUserShape
 * @Return  0:Success 1:Failed
 * @param shape: MapOverLayShapePolygon
 * **/		
	public static int UpdateUserShape(MapOverLayShapePolygon shape)
	{
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_UpdateUserShape,pBuf.length, pBuf);	
		return iRet;
	}

/**
 * UpdateUserShape
 * @Return int 0:Success 1:Failed
 * @param IN shape: MapOverLayShapePolyLine
 * **/	
	public static int UpdateUserShape(MapOverLayShapePolyLine shape)
	{
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_UpdateUserShape,pBuf.length, pBuf);	
		return iRet;
	}
	
	/**
	 * UpdateUserShape
	 * @Return int 0:Success 1:Failed
	 * @param IN shape: MapOverLayShapeVicsLine
	 * **/	
	public static int UpdateUserShape(MapOverLayShapeArc shape)
	{
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_UpdateUserShape,pBuf.length, pBuf);	
		return iRet;
	}
	
	/**
	 * UpdateUserShape
	 * @Return int 0:Success 1:Failed
	 * @param IN shape: MapOverLayShapePoint
	 * **/	
	public static int UpdateUserShape(MapOverLayShapeGround shape)
	{
		int iSize = shape.getSize();
		if (iSize == 0)
		{
			return 1;
		}
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_UpdateUserShape,pBuf.length, pBuf);	
		return iRet;
	}
	
	public static int UpdateUserShape(MapOverLayShapePoints shape)
	{
		int iSize = shape.getSize();
		if (iSize == 0)
		{
			return 1;
		}
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_UpdateUserShape,pBuf.length, pBuf);	
		return iRet;
	}
	
	public static int UpdateUserShapeParam(MapOverLayShape shape)
	{
		Log.i("xxx", "KShapeParam update shape " + shape.m_updateMask);
		int iSize = shape.getSizeBase();
		if (iSize == 0)
		{
			return 1;
		}
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.SerializeBase(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_UpdateUserShapeParam,pBuf.length, pBuf);	
		return iRet;
	}
	
	/**
	 * DelUserShape
	 * @Return int 0:Success 1:Failed
	 * @param IN eType: NE_UserShape_DelRule
	 * @param IN az[]: 
	 * **/
	public static int DelUserShape(NE_UserShape_DelRule eType ,int az[])
	{
		int azLen = 0;
		if (az != null) {
			azLen = az.length;
			
		}
		//[internal]type + vsize + elements
	    int iSize = (2 + azLen)*4;
		byte[] pAllBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iDelRuleType = eType.value();
		ByteUlit.putLong4(pAllBuf,iDelRuleType, iIndex);
		ByteUlit.putLong4(pAllBuf,azLen, iIndex);
		
		for (int i = 0; i < azLen; i++) 
		{
			ByteUlit.putLong4(pAllBuf,az[i], iIndex);
		}
	
		int iRet = MapJni.JNIAPI(APITYPE_DelUserShape,iSize, pAllBuf);	
		return iRet;
	}
	
	/**
	 * SetCachePath
	 * @Return int 0:Success 1:Failed
	 * @param IN CachePath: Cache Path
	 * @param IN eStorageType: Storage Type 0:Inside Card 1: ExtCard
	 * **/
	public static int SetCachePath(String CachePath, KInt eStorageType)
	{
		byte [] bytes= null;

		try 
		{
			bytes = CachePath.getBytes("UTF-8");
		} 
		catch (UnsupportedEncodingException e) 
		{
			e.printStackTrace();
		} 
		//[internal]字符串长度和字符串Buffer
		int iBufSize = bytes.length + 4 + 4;
		byte[] pBuf = new byte[iBufSize];
		KInt iIndex = new KInt(0);
		ByteUlit.SerializeString(pBuf, CachePath, iIndex);
		ByteUlit.putLong4(pBuf, eStorageType.IntVal(), iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_SetCachePath, iBufSize, pBuf);
			
		return iRet;
	}

	/**
	 * SetCachePath
	 * @Return int 0:Success 1:Failed
	 * **/
	public static int ClearCache()
	{
		int iRet = MapJni.JNIAPI(APITYPE_ClearCache, 0, null);
		return iRet;
	}
	
	public static void SetTextSizeZoomRate(float rate)
	{		
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		ByteUlit.putFloat(pBuf, rate, iIndex);
		MapJni.JNIAPI(APITYPE_SetTextSizeZoomRate, iSize, pBuf);
	}
	
	/**
	 * SetCachePath
	 * @Return int 0:Success 1:Failed
	 * @param OUT iCacheSize: Current Cache Size
	 * **/
	public static int GetCurCacheSize(KInt iCacheSize)
	{
		int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetCurCacheSize, iSize, pBuf);
		iCacheSize.PutVal(ByteUlit.getLong4(pBuf, iIndex));
		return iRet;
	}
	
	/**
	 * InitializeRender
	 * @Return int 0:Success 1:Failed
	 * **/
	public static int InitializeRender()
	{
		int iRet = MapJni.JNIAPI(APITYPE_InitializeRender, 0, null);
		return iRet;
	}
	
	/**
	 * Public Function SerialString
	 * **/
	public static byte []  SerialString (String str)
	{
		byte [] bytes = null;
		try 
		{
			bytes = str.getBytes("UTF-8");
		} 
		catch (UnsupportedEncodingException e) 
		{
			e.printStackTrace();
		}  
		
		if(bytes != null)
		{
			int iStrSize = bytes.length;
			ByteBuffer buffer = ByteBuffer.allocate(iStrSize + 4);
			
			buffer.putInt(iStrSize);
			buffer.put(bytes);
			
			return buffer.array();
		
		}
		
		return null;
	}
	
	static ConcurrentHashMap<KHttpData, Integer> mRequestDatas = new ConcurrentHashMap<KHttpData,Integer>();
	public static boolean requestData(KHttpData data) {
		if (NetWorkMonitorReceiver.NetType == NET_TYPE.no_net) {
			return false;
		}
		
		//	防止无限请求
		Integer num = mRequestDatas.get(data);
		if (num == null) {
			mRequestDatas.put(data, Integer.valueOf(1));
		}
		else {
			if (num.intValue() > 15) {
				mRequestDatas.remove(data);
				return false;
			}
			else {
				num = num + 1;
				mRequestDatas.replace(data, num);
			}
		}
		
		Handler mHandler = GlobalSettings.getInstance().getMainThreadHandler();
		if(mHandler != null){
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			Message msg = Message.obtain();
			msg.obj = (data);
			msg.what = GlobalSettings.MESSAGE_NETWORK;
			mHandler.sendMessage(msg);
			return true;
		}
		return false;
	}
	public static void deleteRequest(KHttpData data) {
		mRequestDatas.remove(data);
	}
	
	/**
	 * callByC
	 * @Return int 0:Success 1:Failed
	 * @param IN iType: 
	 * @param IN buf: 
	 * @param IN iBufsize: 
	 * **/
	public static int callByC(int iType, byte[] buf, int iBufsize)
	{
		//Log.d("JNI", "recogHandwritting iType" + iType + " / " +  buf.length);
		//[internal]此回调中请只发消息，不要再调用引擎其它接口
		switch(iType)
		{
		case 30001:
			//[internal] dispatch message to mapview to refresh
			if(MapGestureManager.s_handler != null)
			{
				MapGestureManager.s_handler.sendEmptyMessage(MapGestureManager.GL_REFRESH_MAP);
			}
			break;
		case 30002:
			//[internal]net work
//[internal]			MapGestureManager.m_handler.sendEmptyMessage(MapGestureManager.GL_NETWORK);
			//Log.e("getNetWorkData", "callByC");
			Handler mHandler = GlobalSettings.getInstance().getMainThreadHandler();
			if(mHandler != null){
				//Message msg = new Message();
				Message msg = Message.obtain();
				msg.obj = HttpTool.encodeHttpData(buf);
				KHttpData data = (KHttpData)msg.obj;
				Log.i("download", String.format("callByC.getNetWorkData Type=%d,lv=%d,URL=%s", data.m_data_type, data.m_iLevel, data.m_str_url));
				if(NetWorkMonitorReceiver.NetType != NET_TYPE.no_net) {
					msg.what = GlobalSettings.MESSAGE_NETWORK;
					mHandler.sendMessage(msg);
				} else {
					data.release();
				}
			}
			break;
		case 30003:
			Handler mHandler1 = GlobalSettings.getInstance().getMainThreadHandler();
			if(mHandler1 != null){
				Message msg = Message.obtain();//new Message();
				msg.obj = HttpTool.encodeHttpData(buf);
				msg.what = GlobalSettings.MESSAGE_NETWORK_CLOSE;
				mHandler1.sendMessage(msg);
			}
			break;
		}
		
		return 0;
		
 	}
	
	/**
	 * registerCallback
	 * @Return int 0:Success 1:Failed
	 * **/
	public static int registerCallback()
	{
		int CB_BY_C = 5;
	    int iRegister = MapJni.registerStaticCallback("com/cmmap/internal/mapcore/MapCore",
					"callByC", "(I[BI)I", CB_BY_C);
	   // Log.d("MapJNI", "MapJni callByC = " + iRegister);
			  
			 
	    return iRegister;
	}
	
	/**
	 * SetTranslation
	 * @Return int 0:Success 1:Failed
	 * @param IN iX: X
	 * @param IN iY: Y
	 * **/
	/*
	public static int SetTranslation(int iX , int iY)
	{
    	int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
        ByteUlit.putLong4(pBuf, iX, iIndex);
        ByteUlit.putLong4(pBuf, iY, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_SetTranslation, iSize, pBuf);
		return iRet;
	}
	*/

	/**
	 * GetServiceUrl
	 * @Return byte[] Body Data
	 * @param IN strServiceUrl: Service Url
	 * @param OUT iError: 0:Success 1:Failed
	 * **/
	public static byte[] GetServiceUrl(StringBuffer strServiceUrl, KInt iError)
	{
		int iSize = 512;
		byte[] pBuffer = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetServiceUrl, iSize, pBuffer);
		iError.PutVal(iRet);
		
		strServiceUrl.append( ByteUlit.DerializeString(pBuffer, iIndex) );

		int iBitBufLength =(int) ByteUlit.getLong4(pBuffer, iIndex);
		byte[] bBody = new byte[iBitBufLength];
		
		if (iIndex.IntVal() + iBitBufLength > iSize)
		{
			iError.PutVal(1);
			return null;
		}
		for (int n = 0; n < iBitBufLength; n ++)
		{
			bBody[n] = pBuffer[iIndex.IntVal() + n];
		}
		return bBody;
	}
	
	/**
	 * SetNetworkData
	 * @Return int 0:Success 1:Failed
	 * @param IN data: Network Data
	 * **/
	public static int SetNetworkData(KHttpData httpdata)
	{
		int iSize = httpdata.getSize();
		//byte[] pBuf = new byte[iSize];
		//KInt iIndex = new KInt(0);
		
		//httpdata.Serialize(pBuf, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_SetNetworkData,iSize, httpdata.m_data);
		
		return iRet;
	}

	/**
	 * SetEnableCache
	 * @Return int 0:Success 1:Failed
	 * @param IN bEnable: Enable Cache
	 * **/
	public static int SetEnableCache(boolean bEnable)
	{
    	int iSize = 1;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
        ByteUlit.putboolean(pBuf, bEnable, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_SetEnableCache, iSize, pBuf);
		return iRet;
	}
	
	/**
	 * GetEnableCache
	 * @Return boolean
	 * **/
	public static boolean GetEnableCache( )
	{
		int iSize = 1;
		byte[] pBuffer = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetEnableCache, iSize, pBuffer);
		
		boolean bEnable = ByteUlit.getboolean(pBuffer, iIndex);
		return bEnable;
	}
	
	/**
	 * SetMaxSize
	 * @Return int 0:Success 1:Failed
	 * @param IN iMaxSize: Set Max Map Scale
	 * **/
	public static int SetMaxSize(int iMaxSize)
	{
    	int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
        ByteUlit.putLong4(pBuf, iMaxSize, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_SetMaxSize, iSize, pBuf);
		return iRet;
	}
	
	/**
	 * GetMaxSize
	 * @Return int 0:Success 1:Failed
	 * @param OUT iMaxSize: Max Map Scale
	 * **/
	public static int GetMaxSize(KInt iMaxSize)
	{
		int iSize = 4;
		byte[] pBuffer = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetMaxSize, iSize, pBuffer);
		
		iMaxSize.PutVal(ByteUlit.getLong4(pBuffer, iIndex));
		//System.out.println(iMaxSize.IntVal());
		return iRet;
	}
	
	/**
	 * GetStorageType
	 * @Return int 0:Success 1:Failed
	 * @param OUT StorageType: StorageType 0:Inside Card 1:ExtCard	
	 * **/
	public static int GetStorageType(KInt StorageType)
	{
		int iSize = 4;
		byte[] pBuffer = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetStorageType, iSize, pBuffer);
		
		StorageType.PutVal( ByteUlit.getLong4(pBuffer, iIndex) );
		//System.out.println(StorageType.IntVal());
		return iRet;
	}
	
	/**
	 * GetCacheStorageUsageHint
	 * @Return int 0:Success 1:Failed
	 * @param OUT StorageUsageHint: StorageUsageHint 0:	None 1:Shortage 2:SystemError
	 * **/
	public static int GetCacheStorageUsageHint(KInt StorageUsageHint)
	{
		int iSize = 4;
		byte[] pBuffer = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetCacheStorageUsageHint, iSize, pBuffer);
		
		StorageUsageHint.PutVal(ByteUlit.getLong4(pBuffer, iIndex));
		//System.out.println(StorageUsageHint.IntVal());
		return iRet;
	}
	
	/**
	 * WriteLog
	 * @Return int 0:Success 1:Failed
	 * @param IN logtype: log type
	 * @param IN strLog: Log
	 * **/
	public static int WriteLog(NE_LOG_TYPE logtype, String strLog)
	{
		byte [] byteslog = null;
		try 
		{
			byteslog = strLog.getBytes("UTF-8");
		} 
		catch (UnsupportedEncodingException e) 
		{
			e.printStackTrace();
		} 
		int iSize = 4 + 4 + byteslog.length;
		byte[] pBuffer = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuffer, logtype.value(), iIndex);
		ByteUlit.SerializeString(pBuffer, strLog, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_JniLOG, iSize, pBuffer);
		
		return iRet;
	}
	
	/**
	 * GetTranslation
	 * @Return int 0:Success 1:Failed
	 * @param IN iX: X
	 * @param IN iY: Y
	 * **/
/*	public static int GetTranslation(KInt iX, KInt iY)
	{
		int iSize = 8;
		byte[] pBuffer = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetTranslation, iSize, pBuffer);
		
		iX.PutVal(ByteUlit.getLong4(pBuffer, iIndex));
		iY.PutVal(ByteUlit.getLong4(pBuffer, iIndex));
		
		return iRet;
	}
	*/
	
	public static String GetDataVersion ()
	{
		byte[] pBuffer = new byte[128];
		int iRet = MapJni.JNIAPI(APITYPE_GetDataVersion, 0, pBuffer);
		KInt iIndex = new KInt(0);
		String str = ByteUlit.DerializeString(pBuffer, iIndex);
		return str;
	}
	
	/**
	 * UpdateRTICData
	 * @Return int 0:Success 1:Failed
	 * @param IN iX: X
	 * @param IN iY: Y
	 * **/
	public static int UpdateRTICData(byte[] buf)
	{		
		int iRet = MapJni.JNIAPI(APITYPE_UpdateRTICData, buf.length, buf);		
		return iRet;
	}
	
	public static float GetScalePerPixel()
	{
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetScalePerPixel, iSize, pBuf);	
		
		return ByteUlit.getFloat(pBuf, iIndex);
		
	}
	
	public static int  updateCamera(KCameraUpdate position) {
		
		int iSize = 36;
		byte[]pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		KLatLng latLng = position.targetPosition.target;
		long longi = (long) (latLng.longitude * 1024*3600);
		long lati = (long) (latLng.latitude *1024 *3600);
		
		ByteUlit.putLong4(pBuf, longi, iIndex);
		ByteUlit.putLong4(pBuf, lati, iIndex);
		
		ByteUlit.putFloat(pBuf, position.targetPosition.bearing, iIndex);
		ByteUlit.putFloat(pBuf, position.targetPosition.tilt, iIndex);
		
		float fLevel = 19 - position.targetPosition.zoom;
		ByteUlit.putFloat(pBuf, fLevel, iIndex);
		
		long mask = position.m_byUpdateType;
		ByteUlit.putLong4(pBuf, mask, iIndex);
		MapJni.JNIAPI(APITYPE_UpDateCamera, iSize, pBuf);
		return 0;
	}
	
	public static int SetLocationEnable(boolean bEnable){
		int iSize = 1;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
        ByteUlit.putboolean(pBuf, bEnable, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_SetLocLayerEnable, iSize, pBuf);
		return iRet;
	}
	
	public static boolean GetLocationEnable() {
		int iSize = 1;
		byte[] pBuffer = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetLocLayerEnable, iSize, pBuffer);
		
		boolean bEnable = ByteUlit.getboolean(pBuffer, iIndex);
		return bEnable;
	}
	
	public static void SetLocationStyle(MyLocationStyle style)
	{
		/*
		int iSize = style.getByteSize();
		
		byte[] pBuf = new byte[iSize];
		KInt kIndex = new KInt(0);
		KRECOLOR fillColor = parseColor(style.getRadiusFillColor());
		ByteUlit.putLong4(pBuf,fillColor.r , kIndex);
		ByteUlit.putLong4(pBuf,fillColor.g , kIndex);
		ByteUlit.putLong4(pBuf,fillColor.b , kIndex);
		ByteUlit.putLong4(pBuf,fillColor.a , kIndex);
		
		KRECOLOR strokeColor = parseColor(style.getStrokeColor());
		ByteUlit.putLong4(pBuf,strokeColor.r , kIndex);
		ByteUlit.putLong4(pBuf,strokeColor.g , kIndex);
		ByteUlit.putLong4(pBuf,strokeColor.b , kIndex);
		ByteUlit.putLong4(pBuf,strokeColor.a , kIndex);
		
		ByteUlit.putFloat(pBuf, style.getStrokeWidth(), kIndex);
		
		if(style.getMyLocationIcon() != null)
		{
			if (style.getMyLocationIcon().getBitmap()!= null) {
				ByteUlit.putLong4(pBuf, style.getMyLocationIcon().getBitmap().getWidth(), kIndex);
				ByteUlit.putLong4(pBuf, style.getMyLocationIcon().getBitmap().getWidth(), kIndex);
				
				Bitmap bitmap = style.getMyLocationIcon().getBitmap().copy(Bitmap.Config.ARGB_8888, true);
				ByteBuffer buffer = ByteBuffer.allocate(bitmap.getByteCount());
				Lg.e("zhuliang", "=================== ShapeOverlayFactory createMapPoint buffer.capacity():"+buffer.capacity());
				bitmap.copyPixelsToBuffer(buffer);
				
				System.arraycopy(buffer.array(), 0, pBuf, kIndex.IntVal(), bitmap.getByteCount());
				bitmap.recycle();
				
			}
			else {
				ByteUlit.putLong4(pBuf, 0, kIndex);
				ByteUlit.putLong4(pBuf, 0, kIndex);
			}
		}
		else {
			ByteUlit.putLong4(pBuf, 0, kIndex);
			ByteUlit.putLong4(pBuf, 0, kIndex);
		}
		//ByteUlit.putLong4(pBuf, style.getMyLocationIcon().getBitmap().getWidth(), kIndex);
		//ByteUlit.putFloat(pBuf, style, kIndex);
        //ByteUlit.putboolean(pBuf, bEnable, iIndex);
		MapJni.JNIAPI(APITYPE_SetLocationStyle, iSize, pBuf);
		//return iRet;
		 
		 */
	}
	
	public static MyLocationStyle GetLocationStyle(){
		return null;
		
		/*
		MyLocationStyle style= new MyLocationStyle();
		
		int iSize = 40;
		byte[] pBuffer = new byte[iSize];
		KInt kIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetLocationStyle, iSize, pBuffer);
		int r = ByteUlit.getLong4(pBuffer, kIndex);
		int g = ByteUlit.getLong4(pBuffer, kIndex);
		int b = ByteUlit.getLong4(pBuffer, kIndex);
		int a = ByteUlit.getLong4(pBuffer, kIndex);
		style.radiusFillColor((a<<24)+(r<<16)+(g<<8)+b);
		
		r = ByteUlit.getLong4(pBuffer, kIndex);
		g = ByteUlit.getLong4(pBuffer, kIndex);
		b = ByteUlit.getLong4(pBuffer, kIndex);
		a = ByteUlit.getLong4(pBuffer, kIndex);
		style.strokeColor((a<<24)+(r<<16)+(g<<8)+b);
		
		style.strokeWidth(ByteUlit.getFloat(pBuffer, kIndex));
		//boolean bEnable = ByteUlit.getboolean(pBuffer, iIndex);
		
		return style;
		*/
	}
	
	public static void SetTrafficStyle(MyTrafficStyle style)
	{
		byte[] pBuf = new byte[4*4*4];
		
		
		KInt kIndex = new KInt(0);
		KRECOLOR fillColor = parseColor(style.getCongestedColor());
		ByteUlit.putLong4(pBuf,fillColor.r , kIndex);
		ByteUlit.putLong4(pBuf,fillColor.g , kIndex);
		ByteUlit.putLong4(pBuf,fillColor.b , kIndex);
		ByteUlit.putLong4(pBuf,fillColor.a , kIndex);
		
		KRECOLOR strokeColor = parseColor(style.getSeriousCongestedColor());
		ByteUlit.putLong4(pBuf,strokeColor.r , kIndex);
		ByteUlit.putLong4(pBuf,strokeColor.g , kIndex);
		ByteUlit.putLong4(pBuf,strokeColor.b , kIndex);
		ByteUlit.putLong4(pBuf,strokeColor.a , kIndex);
		
		KRECOLOR slowColor = parseColor(style.getSlowColor());
		
		ByteUlit.putLong4(pBuf,slowColor.r , kIndex);
		ByteUlit.putLong4(pBuf,slowColor.g , kIndex);
		ByteUlit.putLong4(pBuf,slowColor.b , kIndex);
		ByteUlit.putLong4(pBuf,slowColor.a , kIndex);
		
		KRECOLOR smoothColor = parseColor(style.getSmoothColor());
		
		ByteUlit.putLong4(pBuf,smoothColor.r , kIndex);
		ByteUlit.putLong4(pBuf,smoothColor.g , kIndex);
		ByteUlit.putLong4(pBuf,smoothColor.b , kIndex);
		ByteUlit.putLong4(pBuf,smoothColor.a , kIndex);
		
		MapJni.JNIAPI(APITYPE_SetTrafficStyle, 4*4*4, pBuf);
		//APITYPE_SetTrafficStyle
	}
	
	public static MyTrafficStyle GetTrafficStyle()
	{
		MyTrafficStyle style = new MyTrafficStyle();
		byte[] pBuffer = new byte[4*4*4];
		KInt kIndex = new KInt(0);
		
		MapJni.JNIAPI(APITYPE_GetTrafficStyle, 64, pBuffer);
		
		int r = (int)ByteUlit.getLong4(pBuffer, kIndex);
		int g = (int)ByteUlit.getLong4(pBuffer, kIndex);
		int b = (int)ByteUlit.getLong4(pBuffer, kIndex);
		int a =(int) ByteUlit.getLong4(pBuffer, kIndex);
		style.setCongestedColor((a<<24)+(r<<16)+(g<<8)+b);
		
		r = (int)ByteUlit.getLong4(pBuffer, kIndex);
		g = (int)ByteUlit.getLong4(pBuffer, kIndex);
		b = (int)ByteUlit.getLong4(pBuffer, kIndex);
		a = (int)ByteUlit.getLong4(pBuffer, kIndex);
		style.setSeriousCongestedColor((a<<24)+(r<<16)+(g<<8)+b);
		
		r = (int)ByteUlit.getLong4(pBuffer, kIndex);
		g = (int)ByteUlit.getLong4(pBuffer, kIndex);
		b = (int)ByteUlit.getLong4(pBuffer, kIndex);
		a = (int)ByteUlit.getLong4(pBuffer, kIndex);
		style.setSlowColor((a<<24)+(r<<16)+(g<<8)+b);
		
		r = (int)ByteUlit.getLong4(pBuffer, kIndex);
		g = (int)ByteUlit.getLong4(pBuffer, kIndex);
		b = (int)ByteUlit.getLong4(pBuffer, kIndex);
		a = (int)ByteUlit.getLong4(pBuffer, kIndex);
		style.setSmoothColor((a<<24)+(r<<16)+(g<<8)+b);
		return style;
	}
	
	public static void SetMapTextZIndex(float zIndex){
		
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putFloat(pBuf, zIndex, iIndex);
		
		MapJni.JNIAPI(APITYPE_SetMapTextZIndex, iSize, pBuf);
	}
	
	public static float GetMapTextZindex() {
		
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		//ByteUlit.putFloat(pBuf, zIndex, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetMapTextZIndex, iSize, pBuf);
		
		return ByteUlit.getFloat(pBuf, iIndex);
	}
	
	public static void GetMapRotateCenter(KInt x, KInt y) {
		
		int iSize = 8;
		
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
				
		int iRet = MapJni.JNIAPI(APITYPE_GetMapRotateCenter, iSize, pBuf);
		
		x.PutVal(ByteUlit.getLong4(pBuf, iIndex));
		
		y.PutVal(ByteUlit.getLong4(pBuf, iIndex));
	}
	
	public static void SetLocation(Location location){
		//转换二进制
		int iSize = 40;
		byte[]pBuf = new byte[iSize];
		
		long longi = (long) (location.getLongitude() * 1024 *3600);
		long lati = (long) (location.getLatitude() * 1024 *3600);
		
		Log.i("SetLocation", "SetLocation Lon:"+ longi + "Lat:" + lati);
		
		KInt kIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, longi, kIndex);
		ByteUlit.putLong4(pBuf, lati, kIndex);
		
		ByteUlit.putFloat(pBuf, location.getAccuracy(), kIndex);
		ByteUlit.putFloat(pBuf, location.getBearing(),kIndex);
		ByteUlit.putFloat(pBuf, location.getSpeed(), kIndex);
		
		ByteUlit.putLong(pBuf, location.getTime(), kIndex);
		
		MapJni.JNIAPI(APITYPE_SetLocation, iSize, pBuf);
	}
	
	public static void SetSensorAngle(float angle){
		
		int iSize = 8;
		byte[]pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putFloat(pBuf, angle, iIndex);
//		Log.i("position", "angle" + angle);
		int iRet = MapJni.JNIAPI(APITYPE_SetSensorAngle, iSize, pBuf);
//		Log.i("position", "方法执行返回值:" + iRet + "");
	}
	
	public static void OverviewMap(){
		 MapJni.JNIAPI(APITYPE_OverViewMap, 0, null);
	}
	
	public static KCameraPosition OverviewMapEx(LatLngBounds bounds, int width, int height, int padding) {
		int iSize = 512;
		byte[]pBuf = new byte[iSize];
		
		KInt iIndex = new KInt(0);
		
		long temp;
		temp = (long) (bounds.southwest.longitude * 1024 * 3600);
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = (long) (bounds.northeast.longitude * 1024 * 3600);
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = (long) (bounds.northeast.latitude * 1024 * 3600);
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = (long) (bounds.southwest.latitude * 1024 * 3600);
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = (long) width;
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = (long) height;
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = (long) padding;
		ByteUlit.putLong4(pBuf, temp, iIndex);

		int iRet = MapJni.JNIAPI(APITYPE_OverViewMapEx, iSize, pBuf);


		if (iRet == 0) {
			iIndex.PutVal(0);
			KCameraPosition pos = new KCameraPosition();
			long lon,lat;
			lon = ByteUlit.getLong4(pBuf, iIndex);
			lat = ByteUlit.getLong4(pBuf, iIndex);
			pos.target.longitude = (double)lon / 1024.0 / 3600.0;
			pos.target.latitude = (double)lat / 1024.0 / 3600.0;
			pos.bearing = ByteUlit.getFloat(pBuf, iIndex);
			pos.tilt = ByteUlit.getFloat(pBuf, iIndex);
			pos.zoom = ByteUlit.getFloat(pBuf, iIndex);
			return pos;
		}
		return null;
	}
	
	public static boolean ZoomInAndKeepingScreenRelativePosition(int screen_x, int screen_y, boolean is_zoom_in) {
		int iSize = 512;
		byte[]pBuf = new byte[iSize];
		
		KInt iIndex = new KInt(0);
		
		long temp;
		
		temp = (long) screen_x;
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = (long) screen_y;
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = is_zoom_in? 1:0;
		ByteUlit.putLong4(pBuf, temp, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_ZoomInAndKeepingScreenRelativePosition, iSize, pBuf);

		if (iRet == 0) {
			return true;
		}
		
		return false;
	}
	
	public static int CalcPixelZoom(int screen_x, int screen_y, float target_zoom, KLatLng crd) {
		int iSize = 512;
		byte[]pBuf = new byte[iSize];
		
		KInt iIndex = new KInt(0);
		
		long temp;
		
		temp = (long) screen_x;
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = (long) screen_y;
		ByteUlit.putLong4(pBuf, temp, iIndex);
		ByteUlit.putFloat(pBuf, 19.0f - target_zoom, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_CalcPixelZoom, iSize, pBuf);
		
		iIndex.PutVal(0);
		crd.longitude = (double) ByteUlit.getLong4(pBuf, iIndex) / 1024.0 / 3600.0;
		crd.latitude = (double) ByteUlit.getLong4(pBuf, iIndex) / 1024.0 / 3600.0;
		
		return iRet;
	}
	
	public static boolean SelectPOI(KPoi poi,KLatLng latLng){
		int iSize = 512;
		byte[]pBuf = new byte[iSize];
		
		KInt iIndex = new KInt(0);
		long x = (long) (latLng.longitude * 1024 *3600);
		long y = (long) (latLng.latitude * 1024 *3600);
		ByteUlit.putLong4(pBuf, x, iIndex);
		ByteUlit.putLong4(pBuf, y, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_SelectPOI, iSize, pBuf);
		
		if (iRet == 0) {
			iIndex.PutVal(0);
			boolean bEvent = ByteUlit.getboolean(pBuf, iIndex);
			double longi = ByteUlit.getLong4(pBuf, iIndex);
			double lati = ByteUlit.getLong4(pBuf, iIndex);
			poi.SetIsEvent(bEvent);
			poi.SetCoordnate(new KLatLng(lati / 1024/3600, longi/1024/3600));
			poi.SetName(ByteUlit.DerializeString(pBuf, iIndex));
			poi.SetInfo(ByteUlit.DerializeString(pBuf, iIndex));
			poi.setIconType((int) ByteUlit.getLong4(pBuf, iIndex));
			
			return true;
		}
		return false;
		
		
	}
	private static KRECOLOR parseColor(int i_color)
	{
		KRECOLOR k_color = new KRECOLOR();
		int[] pBuf = new int[4];
		pBuf[0] = (i_color >> 24) & 0xff;
		pBuf[1] = (i_color >> 16) & 0xff;
		pBuf[2] = (i_color >> 8) & 0xff;
		pBuf[3] = (i_color >> 0) & 0xff;
		k_color.a = pBuf[0];
		k_color.r = pBuf[1];
		k_color.g = pBuf[2];
		k_color.b = pBuf[3];

		return k_color;
	}
	
	/**
	 * Set RTIC Use
	 * @Return int 0:Success 1:Failed
	 * @param IN bUse: use RTIC
	 * **/		
	public static int SetRTICUse(boolean bUse)
	{
		int iSize = 1;
		byte[] pBuf = new byte[1];
		pBuf[0] = (byte) (bUse ? 0x1 : 0x0);

		int iRet = MapJni.JNIAPI(APITYPE_SetRTICUse, iSize, pBuf);	
		return iRet;
	}

    public static int SetEventUse(boolean enabled) {
        int iSize = 1;
        byte[] pBuf = new byte[1];
        pBuf[0] = (byte) (enabled ? 0x1 : 0x0);

        int iRet = MapJni.JNIAPI(APITYPE_SetEventUse, iSize, pBuf);  
        return iRet;
    }

	/**
	 * Get RTIC Use
	 * @Return int 0:Success 1:Failed
	 * @param OUT rect: Viewport
	 * **/	
	public static boolean GetRTICUse()
	{
		int iSize = 1;
		byte[] pBuf = new byte[iSize];			
		MapJni.JNIAPI(APITYPE_GetRTICUse, iSize, pBuf);
		return pBuf[0] != 0x0 ? true : false;
	}
	
	public static boolean GetEventUse()
	{
	    int iSize = 1;
        byte[] pBuf = new byte[iSize];          
        MapJni.JNIAPI(APITYPE_GetEventUse, iSize, pBuf);
        return pBuf[0] != 0x0 ? true : false;
	}
	
	public static KLatLng StandardToLocatePosition(KLatLng latLng)
	{
		int iSize = 512;
		byte[]pBuf = new byte[iSize];
		
		KInt iIndex = new KInt(0);
		int x = (int) (latLng.longitude * 1024 *3600);
		int y = (int) (latLng.latitude * 1024 *3600);
		ByteUlit.putLong4(pBuf, x, iIndex);
		ByteUlit.putLong4(pBuf, y, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_StandardToLocatePosition, iSize, pBuf);			
		if (iRet == 0) {
			iIndex.PutVal(0);
			double longi = ByteUlit.getLong4(pBuf, iIndex);
			double lati = ByteUlit.getLong4(pBuf, iIndex);
			return new KLatLng(lati / 1024/3600, longi/1024/3600);
		}
		
		return null;
	}

		
	/**
	 * UpdateUserShape
	 * @param shape : MapOverLayShapeNavigateArrow
	 * @return 0:Success 1:Failed
	 */
	public static int UpdateUserShape(MapOverLayShapeNavigateArrow shape) {
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_UpdateUserShape,pBuf.length, pBuf);	
		return iRet;
	}

	/**
	 * AddUserShape
	 * @param shape : MapOverLayShapeNavigateArrow
	 * @return 0:Success 1:Failed
	 */
	public static int AddUserShape(MapOverLayShapeNavigateArrow shape) {
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_AddUserShape,pBuf.length, pBuf);	
		return iRet;
	}
	
	// set_level >= 0 直接设置比例尺
	public static void mapMoveScale(float eventX,float eventY,float rate, int set_level){
		KRect rect = new KRect();
		MapCore.GetMapViewport(rect);
		KInt center_x = new KInt(0);
		KInt center_y = new KInt(0);
		MapCore.GetMapRotateCenter(center_x, center_y);
		int height = (int)rect.iTop - (int)rect.iBottom;
		int offset_x = (int)((center_x.IntVal() - eventX)/rate);
		int offset_y = (int)((center_y.IntVal() - eventY)/rate);
		MapCore.MoveToScreenPt((center_x.IntVal() - offset_x), height - center_y.IntVal() + offset_y, false);
		
		if (set_level >= 0)
		{
			Log.i("scale", "set_level"+set_level);
			// 直接设置比例尺
			MapCore.SetMapScaleLevel(set_level);
		}else
		{
			// 计算缩放比例尺
			KInt scale = new KInt(0);
			MapCore.GetMapScaleValue(scale);
			Log.i("scale", "getScale"+scale.IntVal());
			int new_scale = (int) ((float) (scale.IntVal()) / rate);
			Log.i("scale", "setScale"+new_scale);
			MapCore.SetMapScaleValue(new_scale, false);
		}
	}
		
	public static int calcDistance(KLatLng ptStart, KLatLng ptEnd, KFloat dist) {
		int iSize = 16;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		long longstart = (long) (ptStart.longitude * 1024*3600);
		long latstart = (long) (ptStart.latitude *1024 *3600);
		long longend = (long) (ptEnd.longitude * 1024*3600);
		long latend = (long) (ptEnd.latitude *1024 *3600);
		
		ByteUlit.putLong4(pBuf, longstart, iIndex);
		ByteUlit.putLong4(pBuf, latstart, iIndex);
		ByteUlit.putLong4(pBuf, longend, iIndex);
		ByteUlit.putLong4(pBuf, latend, iIndex);
		
		MapJni.JNIAPI(APITYPE_CalcDistance, iSize, pBuf);
		dist.PutVal(ByteUlit.getFloat(pBuf, new KInt(0))) ;
		return 0;
	}
	
	public static int GetAddressCode(short[] codes) {
		int iSize = 400;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		int iRet = MapJni.JNIAPI(APITYPE_GetAddressCode, iSize, pBuf);
		int num = ByteUlit.getShort2(pBuf, iIndex);
		for(int i = 0; i < num && i < codes.length; ++i) {
			codes[i] = (short) (ByteUlit.getShort2(pBuf, iIndex));
		}
		
		return iRet;
	}

	public static int AddUserShape(MapOverLayShapeMarker shape) {
		int iSize = shape.getSize();
		if (iSize == 0)
		{
			return 1;
		}
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_AddUserShape,pBuf.length, pBuf);	
		return iRet;
	}

	public static int UpdateUserShape(MapOverLayShapeMarker shape) {
		int iSize = shape.getSize();
		if (iSize == 0)
		{
			return 1;
		}
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_UpdateUserShape,pBuf.length, pBuf);	
		return iRet;
	}

	public static void setTileUrl(String strTileUrl, int xOrder, int yOrder, int zOrder) {
		byte [] bytes= null;

		try 
		{
			bytes = strTileUrl.getBytes("UTF-8");
		} 
		catch (UnsupportedEncodingException e) 
		{
			e.printStackTrace();
		} 
		//[internal]字符串长度和字符串Buffer
		int iBufSize = bytes.length + 4 + 4 * 3;
		byte[] pBuf = new byte[iBufSize];
		KInt iIndex = new KInt(0);
		ByteUlit.SerializeString(pBuf, strTileUrl, iIndex);
		ByteUlit.putLong4(pBuf, xOrder, iIndex);
		ByteUlit.putLong4(pBuf, yOrder, iIndex);
		ByteUlit.putLong4(pBuf, zOrder, iIndex);
		
		MapJni.JNIAPI(APITYPE_SetTileUrl, iBufSize, pBuf);
	}
	
	public static int getNet() {
		int iBufSize =   12;
		byte[] pBuf = new byte[iBufSize];
		KInt iIndex = new KInt(0);
		ByteUlit.putFloat(pBuf, iBufSize, iIndex);
		return MapJni.JNIAPI(APITYPE_GetNet, iBufSize, pBuf);
	}
	
	public static int setNet(int netStatus) {
		int iBufSize = 4;
		byte[] pBuf = new byte[iBufSize];
		
		KInt status = new KInt(0);
		ByteUlit.putLong4(pBuf, netStatus, status);
		Log.i("setNet", "setNet:"+netStatus+"");
		return MapJni.JNIAPI(APITYPE_SetNet, iBufSize, pBuf);
	}
	
	public static boolean isPtInPoly(List<KLatLng> ptPoly, KLatLng point) {
		int iBufSize = ptPoly.size() * 8 + 12;
		byte[] pBuf = new byte[iBufSize];
		KInt iIndex = new KInt(0);
		ByteUlit.putLong4(pBuf, ptPoly.size(), iIndex);
		for (KLatLng pt : ptPoly) {
			ByteUlit.putLong4(pBuf, MapTool.doubleToLong(pt.longitude), iIndex);
			ByteUlit.putLong4(pBuf, MapTool.doubleToLong(pt.latitude), iIndex);
		}
		ByteUlit.putLong4(pBuf, MapTool.doubleToLong(point.longitude), iIndex);
		ByteUlit.putLong4(pBuf, MapTool.doubleToLong(point.latitude), iIndex);
		return (MapJni.JNIAPI(APITYPE_IsPtInPoly, iBufSize, pBuf) == 1);
	}
	
	/**
	 * SetMapSwitch
	 * @param eObject MP_ENUM_SWITCH
	 * @param bValue true : open, false : close 
	 * @return 0:Success 1:Failed
	 */
	public static int SetMapSwitch(MP_ENUM_SWITCH eObject, boolean bValue)
	{
		int iSize = 5;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, eObject._value, iIndex);
		ByteUlit.putboolean(pBuf, bValue, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_SetMapSwitch, iSize, pBuf);
	    return iRet;
	}
	
	public static boolean GetMapSwitch(MP_ENUM_SWITCH eObject)
	{
		int iSize = 4;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, eObject._value, iIndex);
		MapJni.JNIAPI(APITYPE_GetMapSwitch, iSize, pBuf);
		
		iIndex = new KInt(0);
		return ByteUlit.getboolean(pBuf, iIndex);
	}
	
	public static boolean SelectPolyline(Point point, KInt id) 
	{
		int iSize = 8;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, point.x, iIndex);
		ByteUlit.putLong4(pBuf, point.y, iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_SelectPolyline, iSize, pBuf);
		 
		 if (iRet == 0) {
			 id.PutVal(ByteUlit.getLong4(pBuf, new KInt(0)));
			 return true;
		}
		
		return false;
	}
	
	public static boolean selectOverlay(Point point, int id) 
	{
		int iSize = 12;
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		
		ByteUlit.putLong4(pBuf, point.x, iIndex);
		ByteUlit.putLong4(pBuf, point.y, iIndex);
		ByteUlit.putLong4(pBuf, id, iIndex);
		
		int iRet = MapJni.JNIAPI(APITYPE_OnOverLayClick, iSize, pBuf);
		
		return (iRet == 0);
	}
	
	/**
	 * AddUserShape
	 * @param shape : MapOverLayShapeNavigateArrow
	 * @return 0:Success 1:Failed
	 */
	public static int AddUserShape(MapOverlayShapeTile shape) {
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_AddUserShape,pBuf.length, pBuf);
		return iRet;
	}
	
	public static int UpdateUserShape(MapOverlayShapeTile shape) {
		int iSize = shape.getSize();
		byte[] pBuf = new byte[iSize];
		KInt iIndex = new KInt(0);
		shape.Serialize(pBuf,iIndex);
		int iRet = MapJni.JNIAPI(APITYPE_UpdateUserShape,pBuf.length, pBuf);	
		return iRet;
	}
	
	public static native int setMapRotateCenter(int x, int y, int is_reset);
	
	static int iNetworkStatus = 1;
	public static int setNetworkStatus(int networkStatus) {
		iNetworkStatus = networkStatus;
		int iBufSize = 4;
		byte[] pBuf = new byte[iBufSize];
		
		KInt dex = new KInt(0);
		ByteUlit.putLong4(pBuf, networkStatus, dex);
		
		int iRet = MapJni.JNIAPI(APITYPE_SetNetworkStatus, iBufSize, pBuf);
		// 网络恢复，刷新地图，获取卫片数据
		if(networkStatus != 0 && MapGestureManager.s_handler != null)
		{
			MapGestureManager.s_handler.sendEmptyMessage(MapGestureManager.GL_REFRESH_MAP);
		}
		return iRet;
	}
	public static int getNetworkStatus() {
		return iNetworkStatus;
	}
	
	public static String getSDKVersion() {
		int iBufSize =   200;
		byte[] pBuf = new byte[iBufSize];
		MapJni.JNIAPI(APITYPE_GetSDKVersion, iBufSize, pBuf);
		KInt kIndex = new KInt(0);
		return ByteUlit.DerializeString(pBuf, kIndex);
	}
	
	public static int getMaxScaleValue(){
		int iBufSize = 200;
		byte[] pBuf = new byte[iBufSize];
		return MapJni.JNIAPI(APITYPE_GetMaxScaleValue, iBufSize, pBuf);
	}
	
	public static int getMinScaleValue(){
		int iBufSize = 200;
		byte[] pBuf = new byte[iBufSize];
		return MapJni.JNIAPI(APITYPE_GetMinScaleValue, iBufSize, pBuf);
	}
	
	public static void clearTileCache(int id) {
		int iBufSize = 4;
		byte[] pBuf = new byte[iBufSize];
		KInt iIndex = new KInt(0);
		ByteUlit.putLong4(pBuf, id, iIndex);
		
		MapJni.JNIAPI(APITYPE_ClearTileCache, iBufSize, pBuf);
	}
	
	public static void setAuthInfo(String strAuth) {
		int iBufSize = strAuth.length() * 2 + 4;
		byte[] pBuf = new byte[iBufSize];
		KInt iIndex = new KInt(0);
		ByteUlit.SerializeString(pBuf, strAuth, iIndex);
		
		MapJni.JNIAPI(APITYPE_SetAuthInfo, iBufSize, pBuf);
	}
	
	//	0(Front) 1(Backgound)
	public static int setRunType(int iRunType) {
		int iBufSize = 4;
		byte[] pBuf = new byte[iBufSize];
		
		KInt dex = new KInt(0);
		ByteUlit.putLong4(pBuf, iRunType, dex);
		
		return MapJni.JNIAPI(APITYPE_SetRunType, iBufSize, pBuf);
	}

	public static KCameraPosition OverviewMapEx(LatLngBounds bounds,
			int leftPadding, int rightPadding, int topPadding, int bottomPadding) {
		int iSize = 32;
		byte[]pBuf = new byte[iSize];
		
		KInt iIndex = new KInt(0);
		
		long temp;
		temp = (long) (bounds.southwest.longitude * 1024 * 3600);
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = (long) (bounds.northeast.longitude * 1024 * 3600);
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = (long) (bounds.northeast.latitude * 1024 * 3600);
		ByteUlit.putLong4(pBuf, temp, iIndex);
		temp = (long) (bounds.southwest.latitude * 1024 * 3600);
		ByteUlit.putLong4(pBuf, temp, iIndex);

		ByteUlit.putLong4(pBuf, leftPadding, iIndex);
		ByteUlit.putLong4(pBuf, rightPadding, iIndex);
		ByteUlit.putLong4(pBuf, topPadding, iIndex);
		ByteUlit.putLong4(pBuf, bottomPadding, iIndex);

		int iRet = MapJni.JNIAPI(APITYPE_OverViewMapExFree, iSize, pBuf);


		if (iRet == 0) {
			iIndex.PutVal(0);
			KCameraPosition pos = new KCameraPosition();
			long lon,lat;
			lon = ByteUlit.getLong4(pBuf, iIndex);
			lat = ByteUlit.getLong4(pBuf, iIndex);
			pos.target.longitude = (double)lon / 1024.0 / 3600.0;
			pos.target.latitude = (double)lat / 1024.0 / 3600.0;
			pos.bearing = ByteUlit.getFloat(pBuf, iIndex);
			pos.tilt = ByteUlit.getFloat(pBuf, iIndex);
			pos.zoom = ByteUlit.getFloat(pBuf, iIndex);
			return pos;
		}
		return null;
	}
	
	public static native void clearMapText();
	
	public static native void setLowMemory(boolean low_memory);
	
	public static native byte [] genMD5(byte[] buf);

    public static String getMapContentApprovalNumber() {
        int iBufSize =   200;
        byte[] pBuf = new byte[200];
        MapJni.JNIAPI(APITYPE_GetMapContentApprovalNumber, iBufSize, pBuf);
        KInt kIndex = new KInt(0);
        return ByteUlit.DerializeGBKString(pBuf, kIndex);
    }

}
