package com.cmmap.internal.mapcore;

import java.util.ArrayList;

import android.graphics.Bitmap;

import com.cmmap.internal.mapcore.offlinemap.entity.CityInfo;
import com.cmmap.internal.mapcore.offlinemap.entity.MapdataInfo;
import com.cmmap.internal.mapcore.offlinemap.entity.ObjectInfo;
import com.cmmap.internal.mapcore.offlinemap.entity.ProvinceInfo;


public class MapJni/* extends Activity */
{
	public static native int JNIAPI(int aPITYPE_Initialize, int iBufSize,
			byte[] pBuf);

	// [internal] 统一的Java向C++注册的回调接口
	public static native int registerStaticCallback(String strClassName,
			String strMethodName, String strMethodSign, int iCallbackID);

	public static native int unregisterCallback(int iCallbackID);

	public static native ArrayList<CityInfo> GetAllMunicipality();
	public native static ArrayList<MapdataInfo> getDownloadinfoByname(
			String name);

	public native static ArrayList<MapdataInfo> getDownloadinfoBycode(
			String code);

	public native static ArrayList<MapdataInfo> getRemoveinfo(String name);

	public native static ArrayList<MapdataInfo> getDownloadinfoByprovincename(
			String name);
	
	
	public static native void drawIntoBitmap(Bitmap image,  int iDeviceWidth, int iDeviceHeight);

	/**
	 * 根据CommonDefine获取数据
	 * 
	 * @param name
	 * @return
	 */
	public native static ProvinceInfo getNationdatainfo(String name);

	public native static CityInfo getitemBycityname(String name);

	public native static CityInfo getitemBycitycode(String code);

	public native static ProvinceInfo getitemByprovincename(String name);

	public native static ProvinceInfo getitemByprovincecode(String code);

	public native static void setCityinfo(CityInfo info);

	public native static void setProvinceinfo(ProvinceInfo info);

	public native static void setMapdatainfo(MapdataInfo info);

	public native static ArrayList<CityInfo> getCitylist();

	public native static ArrayList<ProvinceInfo> getProvincelist();
	
	public native static void init(String path);

	public native static void destroy();

	public native static int getCitylistVersion();

	public native static int getLvl3Version();

	public native static void parserMapfile(String path, int type);

	public native static void setSavepath(String path);

	public native static String getSavepath();
	
	public native static String getOfflineURL(byte[] send);

	public native static int getServerIndex();
	
	public native static void setServerIndex(int iServer);
	//	设置实时交通URL
	public native static void setRTICServer(String strURL);
	//	获取实时交通URL
	public native static String getRTICServer();
	//	设置路况事件URL
	public native static void setEventServer(String strURL);
	//	获取路况事件URL
	public native static String getEventServer();
	//	设置是否使用HTTPS
	public native static void setUseHttps(int iUse);
	//	获取是否使用HTTPS
	public native static int getUseHttps();
	//	获取实时交通是否存在
	public native static boolean isRTICCityExist(int citycode);
	public static void saveInfo(ObjectInfo info) {
		if (info == null) {
			return;
		}
		if (info instanceof CityInfo) {
			setCityinfo(((CityInfo) info));
		}
		if (info instanceof ProvinceInfo) {
			setProvinceinfo(((ProvinceInfo) info));
		}
	}
	
	public native static long UInt32ToInt64(int i);
	
	static {
		System.loadLibrary("cmmap");	
	}
}
