package com.cmmap.internal.mapcore;

import java.util.Vector;


public class MapOverLayShapeArc extends MapOverLayShape{

	
	public KRECOLOR m_strokeColor ;//线的颜色

	public Vector<KGEOCOORD> m_v_points ;//[internal]线的坐标数组

	public float           m_f_width;      //[internal]线条宽度

	
	public MapOverLayShapeArc()
	{
		m_shape_type = NE_MapOverLayShape_Type.MapOverLay_Shape_Arc;
	}
	/**
	* 取序列化的字节数
	*/
	int getSize() {
	return (49 + m_v_points.size()*8);
	}
	
	byte[] Serialize(byte[] pBuf, KInt iIndex) {
		ByteUlit.putboolean(pBuf,m_b_visible,iIndex);
		ByteUlit.putLong4(pBuf, m_i_level, iIndex);
		ByteUlit.putFloat(pBuf, m_i_zindex, iIndex);
		ByteUlit.putLong4(pBuf, m_i_shapid, iIndex);
		ByteUlit.putLong4(pBuf, m_shape_type.value(), iIndex);
		ByteUlit.putLong4(pBuf, m_v_points.size(), iIndex);
		for (int i = 0; i < m_v_points.size(); i++){
			KGEOCOORD p = m_v_points.get(i);
			ByteUlit.putLong4(pBuf, p.lLongitude, iIndex);
			ByteUlit.putLong4(pBuf, p.lLatitude, iIndex);
		}
		ByteUlit.putFloat(pBuf, m_f_width, iIndex);
		ByteUlit.putLong4(pBuf, m_strokeColor.r, iIndex);
		ByteUlit.putLong4(pBuf, m_strokeColor.g, iIndex);
		ByteUlit.putLong4(pBuf, m_strokeColor.b, iIndex);
		ByteUlit.putLong4(pBuf, m_strokeColor.a, iIndex);
		return pBuf;
	}

	MapOverLayShapeArc Derialize(byte[] pBuf, KInt iIndex) {
		m_b_visible = ByteUlit.getboolean(pBuf,iIndex);
		m_i_level = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_i_zindex = ByteUlit.getFloat(pBuf, iIndex);
		m_i_shapid = (int) ByteUlit.getLong4(pBuf, iIndex);
		ByteUlit.getLong4(pBuf, iIndex);
		m_shape_type = NE_MapOverLayShape_Type.MapOverLay_Shape_Arc;
		
		m_v_points = new Vector<KGEOCOORD>();
		int iPontSize = (int) ByteUlit.getLong4(pBuf, iIndex);
		for (int i = 0; i < iPontSize; i++) {
			KGEOCOORD p = new KGEOCOORD();
			p.lLongitude = ByteUlit.getLong4(pBuf, iIndex);
			p.lLatitude = ByteUlit.getLong4(pBuf, iIndex);
			m_v_points.add(p);
		}
		m_f_width = ByteUlit.getFloat(pBuf, iIndex);
		
		m_strokeColor.r = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_strokeColor.g = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_strokeColor.b = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_strokeColor.a = (int)ByteUlit.getLong4(pBuf, iIndex);
		return this;
	}
}
