package com.cmmap.internal.mapcore;

import com.cmmap.api.maps.model.BitmapDescriptor;

public class MapOverLayShapeGround extends MapOverLayShape{

	public BitmapDescriptor m_bitmap;
	public float m_bearing;
	public float m_anchor_u;
    public float m_anchor_v;
    public KRect m_bounds;
    public float m_transparent;
    public float m_width;
    public float m_height;
	
	public MapOverLayShapeGround(BitmapDescriptor bitmap)
	{
		m_shape_type = NE_MapOverLayShape_Type.MapOverLay_Shape_Ground;
		m_bitmap = bitmap;
	}

	int getSize() {
		if (m_bitmap == null)
			return 0;
		else
			return 81 + 16;
	}
	
	byte[] Serialize(byte[] pBuf, KInt iIndex) {
		ByteUlit.putboolean(pBuf,m_b_visible,iIndex);			// 1
		ByteUlit.putLong4(pBuf, m_i_level, iIndex);
		ByteUlit.putFloat(pBuf, m_i_zindex, iIndex);			// 8
		ByteUlit.putLong4(pBuf, m_i_shapid, iIndex);				// 4
		ByteUlit.putLong4(pBuf, m_shape_type.value(), iIndex);	// 4

		if (m_location != null)
		{
			ByteUlit.putLong4(pBuf, m_location.lLongitude, iIndex);	// 4
			ByteUlit.putLong4(pBuf, m_location.lLatitude, iIndex);	// 4
		}else
		{
			ByteUlit.putLong4(pBuf, 0, iIndex);	// 4
			ByteUlit.putLong4(pBuf, 0, iIndex);	// 4
		}
		
		ByteUlit.putFloat(pBuf, m_bearing, iIndex);				// 8
		
		ByteUlit.putFloat(pBuf, m_width, iIndex);				// 8
		ByteUlit.putFloat(pBuf, m_height, iIndex);				// 8
		
		if (m_bitmap == null)
		{
			ByteUlit.putLong4(pBuf, -1, iIndex);	// 4
		}else
		{
			ByteUlit.putLong4(pBuf, m_bitmap.describeContents(), iIndex);	// 4			
		}
	
		ByteUlit.putFloat(pBuf, m_anchor_u, iIndex);			// 8
		ByteUlit.putFloat(pBuf, m_anchor_v, iIndex);			// 8
		
		if (m_bounds != null)
		{
			ByteUlit.putLong4(pBuf, (int)m_bounds.iLeft, iIndex);	// 4
			ByteUlit.putLong4(pBuf, (int)m_bounds.iRight, iIndex);	// 4
			ByteUlit.putLong4(pBuf, (int)m_bounds.iTop, iIndex);		// 4
			ByteUlit.putLong4(pBuf, (int)m_bounds.iBottom, iIndex);	// 4
		}else
		{
			ByteUlit.putLong4(pBuf, 0, iIndex);	// 4
			ByteUlit.putLong4(pBuf, 0, iIndex);	// 4
			ByteUlit.putLong4(pBuf, 0, iIndex);	// 4
			ByteUlit.putLong4(pBuf, 0, iIndex);	// 4
		}
		
		ByteUlit.putFloat(pBuf, m_transparent, iIndex);			// 8
		
		return pBuf;
	}
}
