package com.cmmap.internal.mapcore;

import java.util.ArrayList;

import com.cmmap.api.maps.model.BitmapDescriptor;
import com.cmmap.internal.maps.model.KMarkerOptions;

public class MapOverLayShapeMarker extends MapOverLayShape{

	public KMarkerOptions m_opt = null;
	public int m_bitmap_index;
	public float m_rotate;
	
	public MapOverLayShapeMarker(int id, KMarkerOptions opt, int index, float rotate)
	{
		m_shape_type = NE_MapOverLayShape_Type.MapOverLay_Shape_Marker;
		m_i_shapid = id;
		m_opt = new KMarkerOptions(opt);
		m_bitmap_index = index;
		m_rotate = 360 - rotate;
	}
	
	/**
	* 取序列化的字节数
	*/
	int getSize() {
		if (m_opt == null)
		{
			return 0;
		}
		else
		{
			return 63 + m_opt.getIcons().size() * 4;		// 17 + 26 + 4 + 12 = 59
		}
	}
	
	byte[] Serialize(byte[] pBuf, KInt iIndex) {		
		ByteUlit.putboolean(pBuf, m_b_visible,iIndex);		// 1
		ByteUlit.putLong4(pBuf, m_i_level, iIndex);         // 4
		ByteUlit.putFloat(pBuf, m_i_zindex, iIndex);			// 8
		ByteUlit.putLong4(pBuf, m_i_shapid, iIndex);					// 4
		ByteUlit.putLong4(pBuf, m_shape_type.value(), iIndex);		// 4, total = 17
		
		ByteUlit.putboolean(pBuf, m_opt.isGps(), iIndex);			// 1
		ByteUlit.putboolean(pBuf, m_opt.isFlat(), iIndex);			// 1
		
		ByteUlit.putLong4(pBuf, m_opt.getX(), iIndex);				// 4
		ByteUlit.putLong4(pBuf, m_opt.getY(), iIndex);				// 4
		ByteUlit.putFloat(pBuf, m_opt.getAnchorU(), iIndex);		// 8
		ByteUlit.putFloat(pBuf, m_opt.getAnchorV(), iIndex);		// 8, total = 26
				
		ArrayList<BitmapDescriptor> icons = m_opt.getIcons();
		int bitmap_count = icons.size();
		ByteUlit.putLong4(pBuf, bitmap_count, iIndex);				// 4
		for (int i = 0; i < bitmap_count; i ++)
		{
			ByteUlit.putLong4(pBuf, icons.get(i).describeContents(), iIndex);	// 4
		}
		
		ByteUlit.putLong4(pBuf, m_bitmap_index, iIndex);				// 4

		ByteUlit.putFloat(pBuf, m_rotate, iIndex);					// 8, total = 12
		
		return pBuf;
	}
}
