package com.cmmap.internal.mapcore;

import java.util.Vector;


public class MapOverLayShapeNavigateArrow extends MapOverLayShape{

	
	public KRECOLOR m_sideColor ;//侧边的颜色
	public KRECOLOR m_topColor; // 顶颜色

	public Vector<KGEOCOORD> m_v_points ;//[internal]线的坐标数组

	public float           m_f_width;      //[internal]线条宽度

	
	public MapOverLayShapeNavigateArrow()
	{
		m_shape_type = NE_MapOverLayShape_Type.MapOverLay_Shape_Arrow;
	}
	/**
	* 取序列化的字节数
	*/
	int getSize() {
	return (65 + m_v_points.size()*8);
	}
	
	byte[] Serialize(byte[] pBuf, KInt iIndex) {
		ByteUlit.putboolean(pBuf,m_b_visible,iIndex);
		ByteUlit.putLong4(pBuf, m_i_level, iIndex);
		ByteUlit.putFloat(pBuf, m_i_zindex, iIndex);
		ByteUlit.putLong4(pBuf, m_i_shapid, iIndex);
		ByteUlit.putLong4(pBuf, m_shape_type.value(), iIndex);
		ByteUlit.putLong4(pBuf, m_v_points.size(), iIndex);
		for (int i = 0; i < m_v_points.size(); i++){
			KGEOCOORD p = m_v_points.get(i);
			ByteUlit.putLong4(pBuf, p.lLongitude, iIndex);
			ByteUlit.putLong4(pBuf, p.lLatitude, iIndex);
		}
		ByteUlit.putFloat(pBuf, m_f_width, iIndex);
		ByteUlit.putLong4(pBuf, m_topColor.r, iIndex);
		ByteUlit.putLong4(pBuf, m_topColor.g, iIndex);
		ByteUlit.putLong4(pBuf, m_topColor.b, iIndex);
		ByteUlit.putLong4(pBuf, m_topColor.a, iIndex);
		ByteUlit.putLong4(pBuf, m_sideColor.r, iIndex);
		ByteUlit.putLong4(pBuf, m_sideColor.g, iIndex);
		ByteUlit.putLong4(pBuf, m_sideColor.b, iIndex);
		ByteUlit.putLong4(pBuf, m_sideColor.a, iIndex);
		return pBuf;
	}

	MapOverLayShapeNavigateArrow Derialize(byte[] pBuf, KInt iIndex) {
		m_b_visible = ByteUlit.getboolean(pBuf,iIndex);
		m_i_level = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_i_zindex = ByteUlit.getFloat(pBuf, iIndex);
		m_i_shapid = (int)ByteUlit.getLong4(pBuf, iIndex);
		ByteUlit.getLong4(pBuf, iIndex);
		m_shape_type = NE_MapOverLayShape_Type.MapOverLay_Shape_Arrow;
		
		m_v_points = new Vector<KGEOCOORD>();
		int iPontSize = (int)ByteUlit.getLong4(pBuf, iIndex);
		for (int i = 0; i < iPontSize; i++) {
			KGEOCOORD p = new KGEOCOORD();
			p.lLongitude = ByteUlit.getLong4(pBuf, iIndex);
			p.lLatitude = ByteUlit.getLong4(pBuf, iIndex);
			m_v_points.add(p);
		}
		m_f_width = ByteUlit.getFloat(pBuf, iIndex);
		m_sideColor.r = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_sideColor.g = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_sideColor.b = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_sideColor.a = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_topColor.r = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_topColor.g = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_topColor.b = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_topColor.a = (int)ByteUlit.getLong4(pBuf, iIndex);
		return this;
	}
}
