package com.cmmap.internal.mapcore;

import java.util.Vector;



public class MapOverLayShapePolygon extends MapOverLayShape{

	public KRECOLOR m_color;				//[internal]颜色
	public Vector<KGEOCOORD> m_v_points ;	//[internal]面的坐标数组
	public float  m_borderWidth;			//[internal]边线的宽度
	public KRECOLOR m_borderColor;			//[internal]边线的颜色
	
	public MapOverLayShapePolygon()
	{
		m_shape_type = NE_MapOverLayShape_Type.MapOverLay_Shape_Polygon;
	}
	
	/**
	* 取序列化的字节数
	*/
	int getSize() {
	return (65 + m_v_points.size()*8);
	}
	
	byte[] Serialize(byte[] pBuf, KInt iIndex) {
		ByteUlit.putboolean(pBuf,m_b_visible,iIndex);
		ByteUlit.putLong4(pBuf, m_i_level, iIndex);
		ByteUlit.putFloat(pBuf, m_i_zindex, iIndex);
		ByteUlit.putLong4(pBuf, m_i_shapid, iIndex);
		ByteUlit.putLong4(pBuf, m_shape_type.value(), iIndex);
		ByteUlit.putLong4(pBuf, m_color.r, iIndex);
		ByteUlit.putLong4(pBuf, m_color.g, iIndex);
		ByteUlit.putLong4(pBuf, m_color.b, iIndex);
		ByteUlit.putLong4(pBuf, m_color.a, iIndex);
		ByteUlit.putLong4(pBuf, m_v_points.size(), iIndex);
		for (int i = 0; i < m_v_points.size(); i++){
			KGEOCOORD p = m_v_points.get(i);
			ByteUlit.putLong4(pBuf, p.lLongitude, iIndex);
			ByteUlit.putLong4(pBuf, p.lLatitude, iIndex);
		}
		ByteUlit.putFloat(pBuf, m_borderWidth, iIndex);
		ByteUlit.putLong4(pBuf, m_borderColor.r, iIndex);
		ByteUlit.putLong4(pBuf, m_borderColor.g, iIndex);
		ByteUlit.putLong4(pBuf, m_borderColor.b, iIndex);
		ByteUlit.putLong4(pBuf, m_borderColor.a, iIndex);
		return pBuf;
	}

	MapOverLayShapePolygon Derialize(byte[] pBuf, KInt iIndex) {
		m_b_visible = ByteUlit.getboolean(pBuf,iIndex);
		m_i_level = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_i_zindex = ByteUlit.getFloat(pBuf, iIndex);
		m_i_shapid = (int)ByteUlit.getLong4(pBuf, iIndex);
		ByteUlit.getLong4(pBuf, iIndex);
		m_shape_type = NE_MapOverLayShape_Type.MapOverLay_Shape_Polygon;
		m_color.r =(int) ByteUlit.getLong4(pBuf, iIndex);
		m_color.g =(int) ByteUlit.getLong4(pBuf, iIndex);
		m_color.b =(int) ByteUlit.getLong4(pBuf, iIndex);
		m_color.a = (int)ByteUlit.getLong4(pBuf, iIndex);
		
		m_v_points = new Vector<KGEOCOORD>();
		int iPontSize = (int)ByteUlit.getLong4(pBuf, iIndex);
		for (int i = 0; i < iPontSize; i++) {
			KGEOCOORD p = new KGEOCOORD();
			p.lLongitude = ByteUlit.getLong4(pBuf, iIndex);
			p.lLatitude = ByteUlit.getLong4(pBuf, iIndex);
			m_v_points.add(p);
		}
		m_borderWidth = ByteUlit.getFloat(pBuf, iIndex);
		m_borderColor.r = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_borderColor.g =(int) ByteUlit.getLong4(pBuf, iIndex);
		m_borderColor.b = (int)ByteUlit.getLong4(pBuf, iIndex);
		m_borderColor.a = (int)ByteUlit.getLong4(pBuf, iIndex);
		return this;
	}
}

