package com.cmmap.internal.mapcore;

import java.io.UnsupportedEncodingException;

import com.cmmap.internal.maps.model.KTileOverlayOptions;

public class MapOverlayShapeTile extends MapOverLayShape{
	public KTileOverlayOptions m_opt = null;
	
	public MapOverlayShapeTile(int id, KTileOverlayOptions options)
	{
		m_shape_type = NE_MapOverLayShape_Type.MapOverlay_Shape_Tile;
		m_i_shapid = id;
		m_opt = new KTileOverlayOptions(options);
	}
	
	/**
	* 取序列化的字节数
	*/
	int getSize() {
		int size = 0;
		byte[] diskBytes= null;
		try 
		{
			diskBytes = m_opt.getDiskCacheDir().getBytes("UTF-8");
			size += diskBytes.length + 4;
			size += 39;
		} 
		catch (UnsupportedEncodingException e) 
		{
			e.printStackTrace();
		} 
		
		return size;
	}
	
	byte[] Serialize(byte[] pBuf, KInt iIndex) {
		ByteUlit.putboolean(pBuf, m_b_visible, iIndex);
		ByteUlit.putLong4(pBuf, m_i_level, iIndex);
		ByteUlit.putFloat(pBuf, m_i_zindex, iIndex);
		ByteUlit.putLong4(pBuf, m_i_shapid, iIndex);
		ByteUlit.putLong4(pBuf, m_shape_type.value(), iIndex);
		ByteUlit.putLong4(pBuf, m_opt.getTileProvider().getTileHeight(), iIndex);
		ByteUlit.putLong4(pBuf, m_opt.getTileProvider().getTileWidth(), iIndex);
		ByteUlit.SerializeString(pBuf, m_opt.getDiskCacheDir(), iIndex);
		ByteUlit.putboolean(pBuf, m_opt.getDiskCacheEnabled(), iIndex);
		ByteUlit.putLong4(pBuf, m_opt.getDiskCacheSize(), iIndex);
		ByteUlit.putLong4(pBuf, m_opt.getMemCacheSize(), iIndex);
		ByteUlit.putboolean(pBuf, m_opt.getMemoryCacheEnabled(), iIndex);
		return pBuf;
	}
}
