package com.cmmap.internal.mapcore.offlinemap;

import android.util.Base64;

import com.cmmap.internal.driver.base.HttpTool;
import com.cmmap.internal.mapcore.MapCore;
import com.cmmap.internal.mapcore.MapJni;
import com.cmmap.internal.maps.KMapInitializer;

public class WebServiceUtil {
	public static final String TAG = "WebServiceUtil";
	
	public static int getProportion(float downloadSize, float fileSize) {
		int complete = (int) (downloadSize / fileSize * 100);
		return complete;
	}
	public static byte[] getResponse(byte[] send) {
		String strURL = getOfflineUrl(send);
		return HttpTool.GetMapData(strURL, false);
	}

	public static byte[] intToByteArray(int number) {
		byte[] abyte = new byte[4];
		abyte[0] = (byte) (0xff & number);
		abyte[1] = (byte) ((0xff00 & number) >> 8);
		abyte[2] = (byte) ((0xff0000 & number) >> 16);
		abyte[3] = (byte) ((0xff000000 & number) >> 24);
		return abyte;
	}

	public static byte[] byteMerger(byte[] byte_1, byte[] byte_2) {
		byte[] byte_3 = new byte[byte_1.length + byte_2.length];
		System.arraycopy(byte_1, 0, byte_3, 0, byte_1.length);
		System.arraycopy(byte_2, 0, byte_3, byte_1.length, byte_2.length);
		return byte_3;
	}

	public static int byteArrayToInt(byte[] b) {
		return b[3] & 0xFF | (b[2] & 0xFF) << 8 | (b[1] & 0xFF) << 16
				| (b[0] & 0xFF) << 24;
	}

	public static String getOfflineUrl(byte[] send) {
		String strURL = MapJni.getOfflineURL(send);
		byte type = send[0];
		if(type == 4 || type == 6) {
			strURL += "?mesh=" + Base64.encodeToString(send, Base64.DEFAULT);
		}
		return strURL;
	}
	
	/**
	 * 
	 * @param type webService.SERVICE_URL_TYPE
	 * @param level2 
	 * @param level3
	 * @return
	 */
	public static String findServiceUrl(SERVICE_URL_TYPE type,int level2,int level3) {
		String strKey = KMapInitializer.STR_KEY;
		String strPackageName = KMapInitializer.STR_PACKAGE_NAME;
		String strSha1 = KMapInitializer.STR_SHA1;
		String strSDKVersion = KMapInitializer.strSDKVersion;
	    String strURL = KMapInitializer.strURL;
	    String str_body = "";
		switch (type) {
		case getOfflineDataVersion:
			str_body = "{\"auth\":{\"key\":\"%s\"," + "\"service\":\"1\"," +"\"user\":{\"type\":\"android\","
					+ "\"android\":{\"package_name\":\"%s\","
					+ "\"signature_sha1\":\"%s\"}}," + "\"flow\":0}," + "\"data\":{\"ver\":\"%s\",\"type\":\"offline\",\"func\":\"getOfflineDataVersion\"}}";
			
			str_body = String.format(str_body, strKey, strPackageName, strSha1,strSDKVersion);
			str_body = new StringBuilder(strURL).append("&").append(str_body).toString();
			break;
		case getCityList:
			str_body = "{\"auth\":{\"key\":\"%s\",\"service\":\"1\",\"user\":{\"type\":\"android\",\"android\":{\"package_name\":\"%s\",\"signature_sha1\":\"%s\"}},\"flow\":0},\"data\":{\"ver\":\"%s\",\"type\":\"offline\",\"func\":\"getCityList\"}}";
			str_body = String.format(str_body, strKey, strPackageName, strSha1,strSDKVersion);
			break;
		}
		return str_body;
	}
	
	public enum SERVICE_URL_TYPE{
		getOfflineDataVersion,getCityList
	}

}
