package com.cmmap.internal.mapcore.offlinemap.entity;

import android.os.Parcel;
import android.os.Parcelable;

public class ObjectInfo implements Parcelable {
	public static final String TAG = "ObjectInfo";
	private String mName;
	private int mAdCode;
	private String mPinyin;
	private String mJianpin;
	private int mVersion;
	private String mUri;
	private int mState;
	private int mDownloadsize;
	private int mFilesize;
	private int mType;

	public ObjectInfo(String name, String pinyin, String jianpin, String url,
			int adCode, int version, int state, int cursize, int totalsize,
			int type) {
		mName = name;
		mAdCode = adCode;
		mPinyin = pinyin;
		mJianpin = jianpin;
		mVersion = version;
		mUri = url;
		mState = state;
		mDownloadsize = cursize;
		mFilesize = totalsize;
		mType = type;
	}

	public ObjectInfo(Parcel in) {
		mName = in.readString();
		mAdCode = in.readInt();
		mPinyin = in.readString();
		mJianpin = in.readString();
		mVersion = in.readInt();
		mUri = in.readString();
		mState = in.readInt();
		mDownloadsize = in.readInt();
		mFilesize = in.readInt();
		mType = in.readInt();
	}

	public int getType() {
		return mType;
	}

	public int getAdCode() {
		return mAdCode;
	}

	public String getPinyin() {
		return mPinyin;
	}

	public String getJianpin() {
		return mJianpin;
	}

	public String getUrl() {
		return mUri;
	}

	public int getVersion() {
		return mVersion;
	}

	public String getName() {
		return mName;
	}

	public int getState() {
		return mState;
	}

	public int getDownloadsize() {
		return mDownloadsize;
	}

	public int getFilesize() {
		return mFilesize;
	}

	public void setAdCode(int adCode) {
		mAdCode = adCode;
	}

	public void setPinyin(String pinyin) {
		mPinyin = pinyin;
	}

	public void setJianpin(String jianpin) {
		mJianpin = jianpin;
	}

	public void setUrl(String uri) {
		mUri = uri;
	}

	public void setVersion(int version) {
		mVersion = version;
	}

	public void setName(String name) {
		this.mName = name;
	}

	public void setState(int downloadstate) {
		this.mState = downloadstate;
	}

	public void setDownloadsize(int downloadsize) {
		this.mDownloadsize = downloadsize;
	}

	public void setFilesize(int filesize) {
		this.mFilesize = filesize;
	}

	public void setType(int type) {
		this.mType = type;
	}

	@Override
	public int describeContents() {
		return 0;
	}

	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeString(mName);
		dest.writeInt(mAdCode);
		dest.writeString(mPinyin);
		dest.writeString(mJianpin);
		dest.writeInt(mVersion);
		dest.writeString(mUri);
		dest.writeInt(mState);
		dest.writeInt(mDownloadsize);
		dest.writeInt(mFilesize);
		dest.writeInt(mType);
	}

	public static final Parcelable.Creator<ObjectInfo> CREATOR = new Parcelable.Creator<ObjectInfo>() {
		public ObjectInfo createFromParcel(Parcel in) {
			return new ObjectInfo(in);
		}

		public ObjectInfo[] newArray(int size) {
			return new ObjectInfo[size];
		}
	};

}
