package com.cmmap.internal.mapcore.offlinemap.entity;

import java.util.ArrayList;

public class ProvinceInfo extends ObjectInfo {
	public static final String TAG = CityInfo.class.getName();

	/**
	 * 省份信息包含城市信息
	 */
	private ArrayList<CityInfo> mCitylist;

	public ProvinceInfo(String name, String pinyin, String jianpin, String url, ArrayList<CityInfo> citylist, int code, int version, int state, int cursize, int totalsize, int type) {
		super(name, pinyin, jianpin, url, code, version, state, cursize, totalsize, type);
		//如果该省份下没有任何城市的话 给它制造一个城市
		if (citylist == null || citylist.isEmpty()) {
			CityInfo cityInfo = new CityInfo(name, pinyin, jianpin, url, code, version, state, cursize, totalsize, type, code, 0);
			citylist = new ArrayList<CityInfo>();
			citylist.add(cityInfo);
		}
		mCitylist = citylist;
	}

	public ArrayList<CityInfo> getCitylist() {
		return mCitylist;
	}

	public void setCitylist(ArrayList<CityInfo> list) {
		this.mCitylist = list;
	}
}
