package com.cmmap.internal.maps.model;

import com.cmmap.api.maps.model.CameraPosition;


/**
 * 地图可视区域控制范围
 * 
 * 
 */
public class KCameraPosition {

	/**
	 * 旋转角度
	 */
	public float bearing;	// 可视区域指向的方向，以角度为单位，从正北向顺时针方向计算，从0 度到360 度。

	/**
	 * 倾角
	 */
	public float tilt;

	/**
	 * 缩放比例
	 */
	public float zoom;

	/**
	 * 当前中心点坐标
	 */
	public KLatLng target;


	// bearing - 可视区域指向的方向，以角度为单位，从正北向顺时针方向计算，从0度到360度。	
	public KCameraPosition(KLatLng target, float zoom, float tilt, float bearing) {
		this.bearing = bearing;
		this.tilt = tilt;
		this.zoom = zoom;
		this.target = new KLatLng(target);
	}

	public KCameraPosition() {
		bearing = 0;
		target = new KLatLng(0, 0);
		zoom = 2;
		tilt = 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (obj == null) {
			return false;
		}
		if (!(obj instanceof KCameraPosition)) {
			return false;
		}

		KCameraPosition param = (KCameraPosition) obj;

		if ((!(this.target != null && param.target != null))
				|| !this.target.equals(param.target)) {
			return false;
		}

		if (Float.compare(this.bearing, param.bearing) != 0) {
			return false;
		}
		if (Float.compare(this.zoom, param.zoom) != 0) {
			return false;
		}
		if (Float.compare(this.tilt, param.tilt) != 0) {
			return false;
		}

		return true;
	}
	
	public CameraPosition toCameraPosition() {
		return new CameraPosition(target.toLatLng(), zoom, tilt, bearing);
	}
}
