package com.cmmap.internal.maps.model;

import java.io.IOException;
import java.io.InputStream;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.graphics.drawable.NinePatchDrawable;
import android.os.Build;
import android.text.TextUtils.TruncateAt;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.cmmap.internal.driver.base.GlobalSettings;

/**
 * 情報表示window
 * 
 * @author liangz
 * 
 */
public class KDefaultInfoWindowView extends LinearLayout {

	private KMarker marker;
	
	private Drawable bkDrawable;
	
	private TextView snipetTextView;
	
	private TextView titleTextView;
	
	
	public KDefaultInfoWindowView(Context context,KMarker marker) {
		super(context);
		
		this.marker = marker;
		
		initView(false);
	}
	
	public KDefaultInfoWindowView(Context context, View viewContent){
		super(context);
		
		initView(true);
		
		viewContent.setPadding(5, 10, 5, 20);
		addView(viewContent);
	}

	private void initView(boolean bContent){
		if (GlobalSettings.getInstance().getContext() == null) {
			return;
		}
		LinearLayout.LayoutParams params = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT);
		setLayoutParams(params);
		if(bContent)
		{
			initBackground();
		}
		// 客户要求不实现默认infowindow
//		else if((marker.getTitle() == null || marker.getTitle().isEmpty())
//				&& (marker.getSnippet() == null || marker.getSnippet().isEmpty())) 
//		{
//			return;
//		}
		else
		{
//			initdefView();
			return;
		}
	}
	
	@Override
	protected void onLayout(boolean changed, int l, int t, int r, int b) {
		super.onLayout(changed, l, t, r, b);
		
		//initdefView();
	}
	
	private void initBackground(){
		try {
			InputStream is = getResources().getAssets().open("cmmap/mapres/infowindow_bg.9.png");
			bkDrawable = NinePatchDrawable.createFromStream(is, null);
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		if(bkDrawable != null)
		{
			if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN)
			{
				setBackground(bkDrawable);
			}
			else
			{
				setBackgroundDrawable(bkDrawable);
			}
		}
	}
	
	private void initdefView()
	{	
		initBackground();
		this.setOrientation(VERTICAL);
		
		titleTextView = new TextView(GlobalSettings.getInstance().getContext());
		LinearLayout.LayoutParams titleParams = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT);
		titleParams.setMargins(10, 0, 10, 0);
		titleTextView.setTextSize(16);
		titleTextView.setText(marker.getTitle());
		titleTextView.setSingleLine(true);
		titleTextView.setEllipsize(TruncateAt.END);
		titleTextView.setLayoutParams(titleParams);	
		titleTextView.setId(marker.getOverlayId() * 10 + 3);
		addView(titleTextView);
		
		snipetTextView = new TextView(GlobalSettings.getInstance().getContext());	
		LinearLayout.LayoutParams snipetParams = new LinearLayout.LayoutParams(LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT);
		//snipetParams.addRule(RelativeLayout.BELOW, titleTextView.getId());
		snipetParams.setMargins(10, 0, 10, 20);
		snipetTextView.setTextSize(14);
		snipetTextView.setSingleLine(true);
		snipetTextView.setEllipsize(TruncateAt.END);
		snipetTextView.setText(marker.getSnippet());
		snipetTextView.setLayoutParams(snipetParams);
		snipetTextView.setId(marker.getOverlayId() * 10 + 4);
		addView(snipetTextView);
	}
}
