package com.cmmap.internal.maps.model;

/**
 * Overlay属性变化的监听器，不对外使用。
 * 
 *
 */
public interface KOverlayListener {	
	/**
	 * 属性更新
	 * @param _id
	 */
	void firePropertyChange(int _id, int updateMask);
	
	/**
	 * overlay的纹理资源删除
	 * @param _id
	 */
	void overlayImageRemove(int _id);
	
	/**
	 * overlay的纹理资源变更
	 * @param _id
	 */
	void overlayImageChange(int _id);

	/**
	 * 删除
	 * @param _id
	 */
	void remove(int _id);
	
	/**
	 * 更新level
	 * @param _id
	 */
	void updateLevel(int _id);
	
	/**
	 * 更新zIndex
	 * @param _id
	 */
	void updateZIndex(int _id);
	
	/**
	 * 清理缓存
	 * @param _id
	 */
	void clearCache(int _id);
}
