package com.cmmap.internal.services.rtic;

public class ByteHelper {

	public static final int C_VERSION = 20160127;
    /** 
     * 将byte[]转换为byte 
     *  
     * @param res 
     *            byte[] 
     * @return int 
     * */  
    public static byte byteArray2Byte(byte[] buf, int pos) {  
        byte value = buf[pos];
        return value;  
    } 
    /** 
     * 将byte[]转换为short
     *  
     * @param res 
     *            byte[] 
     * @return int 
     * */  
    public static short byteArray2Short(byte[] buf, int pos) {
		int value = (buf[pos + 1] & 0xFF) | ((buf[pos + 0] << 8) & 0xff00);
        return (short) value;  
    } 
    /** 
     * 将byte[]转换为32位int 
     *  
     * @param res 
     *            byte[] 
     * @return int 
     * */  
    public static int byteArray2Int(byte[] buf, int pos) {   
        int targets = (buf[pos+3] & 0xff) | ((buf[pos+2] << 8) & 0xff00) |
        		((buf[pos+1] << 16) & 0xff0000) | ((buf[pos+0] << 24) & 0xff000000); 
        return targets;  
    }
    /** 
     * 将byte[]转换为String 
     *  
     * @param res 
     *            byte[] 
     * @return int 
     * */  
    public static String byteArray2String(byte[] buf, int pos) {  
        int len = byteArray2Int(buf, pos);
        pos += 4;
        
        String str = new String(buf, pos, len);
        return str;  
    }
 
    /** 
     * 将short转换为byte[] 
     *  
     * @param s 
     *            short 
     * @return byte[] 字节数组
     * */  
    public static byte[] shortToByteArray(short s, byte[] buf, int pos) { 
        for (int i = 0; i < 2; i++) {  
            int offset = i * 8;  
            buf[pos+2-i-1] = (byte) ((s >>> offset) & 0xff);  
        }  
        return buf;  
    }  
  
    /** 
     * 将32位int转换为byte[]  
     *  
     * @param s 
     *            int 
     * @return byte[] 
     * */  
    public static byte[] intToByteArray(int s, byte[] buf, int pos) { 
        for (int i = 0; i < 4; i++) {  
            int offset = (i) * 8;  
            buf[pos+4-i-1] = (byte) ((s >>> offset) & 0xff);  
        }
        return buf;  
    }
    /** 
     * 将String转换为byte[]  
     *  
     * @param s 
     *            int 
     * @return byte[] 
     * */  
    public static byte[] StringToByteArray(String str, byte[] buf, int pos) {
    	byte[] data =str.getBytes();
    	intToByteArray(data.length, buf, pos);
    	pos += 4;

    	System.arraycopy(data, 0, buf, pos, data.length);
        return buf;  
    }    
    public static String getVersionByInt(int j) {

		byte[] b = new byte[4];

		b = ByteHelper.intToByteArray(j, b, 0);
		// Log.i("20160716", "byte 0 :" + b[0]);
		byte[] byte1 = new byte[4];
		byte1[2] = b[0];
		byte1[3] = b[1];
		byte[] byte2 = new byte[4];
		byte2[2] = b[2];
		byte2[3] = b[3];

		int int0 = ByteHelper.byteArray2Int(byte1, 0);
		int int1 = ByteHelper.byteArray2Int(byte2, 0);
		String string0 = Integer.toString(int0);
		String string1 = Integer.toString(int1);
		String offVersion = new String(string0 + "." + string1);
		return offVersion;
	}
}
