package com.cmmap.internal.services.rtic;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;

import android.util.Log;
public class RTICCity {
	java.util.List<RTICLink> m_lst_link = new ArrayList<RTICLink>();
	String m_strCity = "";
	String m_strDateTime = "";
	int m_date;
	int m_time;
	
	//	GetDateTime
	public String GetDateTime() {
		return m_strDateTime;
	}
	//	GetDate
	public int GetDate() {
		return m_date;
	}
	//	GetTime
	public int GetTime() {
		return m_time;
	}
	//	GetCity
	public String GetCity() {
		return m_strCity;
	}
	
	//	Get Buffer Size
	public int Size() {
		return 12 + 4 + m_lst_link.size() * RTICLink.Size();
	}
	
	// Write To Buffer
	public int WriteToBuf(byte[] buf, int pos) {
		if(m_lst_link == null) {
			return 0;
		}		
		int ofs = pos;
		
		int iCity = Integer.parseInt(m_strCity);
		ByteHelper.intToByteArray(iCity, buf, ofs);
		ofs += 4;
		
		ByteHelper.intToByteArray(m_date, buf, ofs);
		ofs += 4;
		
		ByteHelper.intToByteArray(m_time, buf, ofs);
		ofs += 4;
		
		int iSize = m_lst_link.size();
		ByteHelper.intToByteArray(iSize, buf, ofs);
		ofs += 4;
		
		for(int i = 0; i < iSize; ++i) {
			RTICLink lnk = m_lst_link.get(i);
			ofs += lnk.WriteToBuf(buf, ofs);
		}
		return ofs - pos;
	}
	
	//	从buf从解析数据
	//	返回值:0(OK),1(error_city_code),2(no change), 3(no data),255(other)
	public int LoadFromByte(byte[] buf, String strCity) {
		m_strCity = strCity;
		int pos = 0;
		String strstatus = ByteHelper.byteArray2String(buf, pos);
		pos += 4 + strstatus.length();
		
		String strstatus_ms = ByteHelper.byteArray2String(buf, pos);
		pos += 4 + strstatus_ms.length();
		
		Log.i("RTIC", "RTICCity.LoadFromByte city="+strCity + "|status="+strstatus + "|ms="+strstatus_ms);
		if(strstatus.compareToIgnoreCase("ok") != 0) {
			if(strstatus_ms.compareToIgnoreCase("error_city_code") == 0) {
				return 1;
			}
			return 255;
		}
		else {
			if(strstatus_ms.compareToIgnoreCase("tmc_data no change") == 0) {
				return 2;
			}
		}
		
		if(pos == buf.length) {
			return 3;
		}
		
		m_strDateTime = ByteHelper.byteArray2String(buf, pos);
		pos += 4 + m_strDateTime.length();
		
		if(m_strDateTime != null && m_strDateTime.length() > 8) {
			m_time = Integer.parseInt(m_strDateTime.substring(8));
			m_date = Integer.parseInt(m_strDateTime.substring(0,8));
		}
		Log.i("RTIC", "date=" + m_date + "|Time=" + m_time);
		int dataSize = ByteHelper.byteArray2Int(buf, pos);
		pos += 4;
		
		for(int i = 0; i < dataSize; ++i) {
			short idSize = ByteHelper.byteArray2Short(buf, pos);
			pos += 2;
			
			int[] ids = new int[idSize];
			for(short j = 0; j < idSize; ++j) {
				int key =  ByteHelper.byteArray2Int(buf, pos);
				if(key < 0) {
					ids[j] = (java.lang.Math.abs(key) << 1) + 1;
				} else {
					ids[j] = key << 1;
				}
				pos += 4;
			}
			Arrays.sort(ids);
			
			short speed = ByteHelper.byteArray2Short(buf, pos);
			pos += 2;
			byte time = ByteHelper.byteArray2Byte(buf, pos);
			pos += 1;
			byte avoid = ByteHelper.byteArray2Byte(buf, pos);
			pos += 1;
			short event = ByteHelper.byteArray2Short(buf, pos);
			pos += 2;
			byte jam = ConvertEventID(event);
			
			short plusSize = ByteHelper.byteArray2Short(buf, pos);
			pos += 2;			
			java.util.List<RTICPlus> lst_plus = new ArrayList(plusSize);
			for(short k = 0; k < plusSize; ++k) {
				int ps_startMeter = ByteHelper.byteArray2Int(buf, pos);
				pos += 4;
				int ps_endMeter = ByteHelper.byteArray2Int(buf, pos);
				pos += 4;
				short ps_speed = ByteHelper.byteArray2Short(buf, pos);
				pos += 2;
				short ps_eventID = ByteHelper.byteArray2Short(buf, pos);
				pos += 2;
				RTICPlus plus = new RTICPlus(ps_startMeter, ps_endMeter, ps_speed, ConvertEventID(ps_eventID));
				lst_plus.add(plus);
			}
			
			RTICLink lnk = null;
			for(short m = 0; m < idSize; ++m) {
				int iID = ids[m] >> 1;
				byte dir = (byte) ((ids[m] & 0x1) );
				if(null == lnk) {
					lnk = new RTICLink(iID, (byte) 0, dir, jam, (byte)(speed));
					lnk.m_lst_plus = lst_plus;
					m_lst_link.add(lnk);
				}
				else {
					if((lnk.m_lnkID + lnk.m_diffID + 1 == iID) && (lnk.m_dir == dir)) {
						lnk.m_diffID++;
					}
					else {
						lnk = new RTICLink(iID, (byte) 0, dir, jam, (byte)(speed));
						lnk.m_lst_plus = lst_plus;
						m_lst_link.add(lnk);
					}
				}
			}
		}
		
		if(null != m_lst_link) {
			java.util.Collections.sort(m_lst_link,
					new Comparator<RTICLink>() {
				public int compare(RTICLink arg0, RTICLink arg1) {
					if(arg0.m_lnkID == arg1.m_lnkID) {
						return arg0.m_dir - arg1.m_dir;
					}
					return arg0.m_lnkID - arg1.m_lnkID;
				}
			});
		}
		return 0;
	}
	
	//	Convert EventID
	byte ConvertEventID(short id) {
		byte value = 0;
		switch(id) {
		case 101:
			value = RTICLink.LJS_FAST;
			break;
		case 115:
			value = RTICLink.LJS_SLOW;
			break;
		case 122:
			value = RTICLink.LJS_JAM;
			break;
		default:
			value = RTICLink.LJS_UNKNOWN;
			break;
		}
		return value;
	}
}
